/**
* Copyright (C) 2020 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.databaseAdmin.preferencePage;

import eu.etaxonomy.cdm.model.metadata.CdmPreference;
import eu.etaxonomy.cdm.model.metadata.PreferencePredicate;
import eu.etaxonomy.taxeditor.preference.DistributionDetailsViewPreference;
import eu.etaxonomy.taxeditor.preference.PreferencesUtil;

/**
 * @author k.luther
 * @since Apr 8, 2020
 */
public class DistributionDetailsViewAdminPreference extends DistributionDetailsViewPreference {
    @Override
    public void getValues(){
        isAdminPreference = true;

        prefShowIdInVoc = PreferencesUtil.getPreferenceFromDB(PreferencePredicate.NamedAreaWithIdInVoc);

        allowOverrideShowIdInVoc = getPrefAllowOverride(prefShowIdInVoc);
        isShowIdInVoc = getBooleanPrefValue(prefShowIdInVoc);
   }

    @Override
    public boolean performOk() {
        if (isApply()){
            prefShowIdInVoc = CdmPreference.NewTaxEditorInstance(PreferencePredicate.NamedAreaWithIdInVoc, isShowIdInVoc != null? Boolean.toString(this.isShowIdInVoc): null);
            prefShowIdInVoc.setAllowOverride(allowOverrideShowIdInVoc);
            PreferencesUtil.setPreferenceToDB(prefShowIdInVoc);
            setApply(false);
        }
        return true;
    }

}
