/**
* Copyright (C) 2019 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.databaseAdmin.preferencePage;

import eu.etaxonomy.cdm.model.metadata.CdmPreference;
import eu.etaxonomy.cdm.model.metadata.PreferencePredicate;
import eu.etaxonomy.taxeditor.preference.FactualDataPreference;
import eu.etaxonomy.taxeditor.preference.PreferencesUtil;

/**
 * @author k.luther
 * @since 25.09.2019
 */
public class FactualDataAdminPreferencePage extends FactualDataPreference {


    @Override
    public void getValues(){
        isAdminPreference = true;
        pref = PreferencesUtil.getPreferenceFromDB(PreferencePredicate.ShowModifier);

        allowOverride = getPrefAllowOverride(pref);

        isShowModifier = getBooleanPrefValue(pref);

        //get modifier freetext values
        prefFreeText = PreferencesUtil.getPreferenceFromDB(PreferencePredicate.ShowModifierFreeText);

        allowOverrideFreeText = getPrefAllowOverride(prefFreeText);
        isShowModifierFreeText = getBooleanPrefValue(prefFreeText);
    }



    @Override
    public boolean performOk() {
        if (isApply()){
            pref = CdmPreference.NewTaxEditorInstance(PreferencePredicate.ShowModifier, isShowModifier != null? Boolean.toString(this.isShowModifier): null);
            pref.setAllowOverride(allowOverride);
            PreferencesUtil.setPreferenceToDB(pref);

            prefFreeText = CdmPreference.NewTaxEditorInstance(PreferencePredicate.ShowModifierFreeText, isShowModifierFreeText != null? Boolean.toString(this.isShowModifierFreeText): null);
            prefFreeText.setAllowOverride(allowOverrideFreeText);
            PreferencesUtil.setPreferenceToDB(prefFreeText);
            setApply(false);
        }
        return true;
    }



}
