/**
* Copyright (C) 2019 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.databaseAdmin.preferencePage;

import eu.etaxonomy.cdm.model.metadata.PreferencePredicate;
import eu.etaxonomy.cdm.model.term.TermType;
import eu.etaxonomy.taxeditor.editor.definedterm.input.TermEditorInput;
import eu.etaxonomy.taxeditor.preference.menu.FeatureMenuPreferences;

/**
 * @author k.luther
 * @since 03.09.2019
 */
public class FeatureAdminMenuPreference extends FeatureMenuPreferences {
    /**
     * <p>Constructor for FeatureMenuPreference.</p>
     */
    public FeatureAdminMenuPreference() {
        super();
        isAdminPreference = true;
        setPredicate(PreferencePredicate.TaxonFeatures);
        type = TermType.Feature;
    }

    @Override
    public boolean performOk() {
        if (!isApply()){
            return true;
        }

        boolean result = performOkAdmin();
        if (result){
            TermEditorInput.getPreferredTaxonFeatureTree(true);
        }
        return result;
    }


}
