/**
* Copyright (C) 2018 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.databaseAdmin.preferencePage;

import eu.etaxonomy.cdm.model.metadata.CdmPreference;
import eu.etaxonomy.cdm.model.metadata.PreferencePredicate;
import eu.etaxonomy.taxeditor.preference.GeneralPreferencePage;
import eu.etaxonomy.taxeditor.preference.PreferencesUtil;

/**
 * @author k.luther
 * @since 29.05.2018
 *
 */
public class GeneralAdminPreferencePage extends GeneralPreferencePage implements IE4AdminPreferencePage {


    CdmPreference isShowSpecimenPref = null;
    /**
     * {@inheritDoc}
     */


    @Override
    public boolean performOk() {
        if (!isApply()){
            return true;
        }
        CdmPreference pref = CdmPreference.NewTaxEditorInstance(PreferencePredicate.ShowChecklistPerspective, isShowCheckListPerspective!= null? Boolean.toString(this.isShowCheckListPerspective):null);
        pref.setAllowOverride(isAllowOverrideShowCheckListPerspective);
        PreferencesUtil.setPreferenceToDB(pref);
        setApply(false);
        return true;

   }
    @Override
    protected void getValues(){
        isAdminPreference = true;
        CdmPreference pref = PreferencesUtil.getPreferenceFromDB(PreferencePredicate.ShowChecklistPerspective);
        if (pref != null){
            isShowCheckListPerspective = pref.getValue()!= null?Boolean.valueOf(pref.getValue()): null;
            isAllowOverrideShowCheckListPerspective = pref.isAllowOverride();
        }else{
            isShowCheckListPerspective = null;
            isAllowOverrideShowCheckListPerspective = true;
        }
    }

    @Override
    protected void performDefaults() {
        isShowCheckListPerspective = null;
        isAllowOverrideShowCheckListPerspective = true;
        setSelections();
        super.performDefaults();
    }

}
