/**
* Copyright (C) 2020 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.databaseAdmin.preferencePage;

import eu.etaxonomy.cdm.model.metadata.CdmPreference;
import eu.etaxonomy.cdm.model.metadata.PreferencePredicate;
import eu.etaxonomy.taxeditor.preference.IOPreferences;
import eu.etaxonomy.taxeditor.preference.PreferencesUtil;

/**
 * @author k.luther
 * @since 11.02.2020
 */
public class IOAdminPreferences extends IOPreferences {
    @Override
    public boolean performOk() {
       if (!isApply()){
           return true;
       }
       showIOMenuPref = CdmPreference.NewTaxEditorInstance(PreferencePredicate.ShowImportExportMenu, isShowIOMenu!= null? Boolean.toString(this.isShowIOMenu):null);
       showIOMenuPref.setAllowOverride(isAllowOverrideShowIOMenu);
       PreferencesUtil.setPreferenceToDB(showIOMenuPref);
       setApply(false);
       return true;

    }

    @Override
    protected void getValues(){
        isAdminPreference = true;
        showIOMenuPref = PreferencesUtil.getPreferenceFromDB(PreferencePredicate.ShowImportExportMenu);
        if (showIOMenuPref != null){
              isShowIOMenu = showIOMenuPref.getValue()!= null?Boolean.valueOf(showIOMenuPref.getValue()): null;
              isAllowOverrideShowIOMenu = showIOMenuPref.isAllowOverride();
          }else{
              isShowIOMenu = null;
              isAllowOverrideShowIOMenu = true;
          }
    }

    @Override
    protected void performDefaults() {
        isShowIOMenu = null;
        isAllowOverrideShowIOMenu = true;

        setSelections();
        super.performDefaults();
    }

}
