/**
* Copyright (C) 2020 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.databaseAdmin.preferencePage;

import eu.etaxonomy.cdm.model.metadata.PreferencePredicate;
import eu.etaxonomy.cdm.model.term.TermType;
import eu.etaxonomy.taxeditor.preference.menu.MarkerTypeMenuPreferences;

/**
 * @author k.luther
 * @since Feb 13, 2020
 */
public class MarkerTypeMenuAdminPreferences extends MarkerTypeMenuPreferences {

    public MarkerTypeMenuAdminPreferences() {
        super();
        isAdminPreference = true;
        setPredicate(PreferencePredicate.MarkerTypes);
        type = TermType.MarkerType;
    }

    @Override
    public boolean performOk() {
        if (!isApply()){
            return true;
        }
        return performOkAdmin();
    }

}
