package eu.etaxonomy.taxeditor.databaseAdmin.preferencePage;


import eu.etaxonomy.cdm.api.application.ICdmRepository;
import eu.etaxonomy.cdm.api.service.IPreferenceService;
import eu.etaxonomy.cdm.model.metadata.CdmPreference;
import eu.etaxonomy.cdm.model.metadata.CdmPreference.PrefKey;
import eu.etaxonomy.cdm.model.metadata.PreferencePredicate;
import eu.etaxonomy.cdm.model.metadata.PreferenceSubject;
import eu.etaxonomy.taxeditor.preference.CdmPreferenceCache;
import eu.etaxonomy.taxeditor.preference.NameDetailsConfigurator;
import eu.etaxonomy.taxeditor.preference.NameDetailsViewConfiguration;
import eu.etaxonomy.taxeditor.preference.PreferencesUtil;
import eu.etaxonomy.taxeditor.store.CdmStore;


public class NameDetailsViewAdminConfiguration extends NameDetailsViewConfiguration implements IE4AdminPreferencePage{




//protected NameDetailsConfigurator createNameDetailsViewConfig() {
//
//      NameDetailsConfigurator config = new NameDetailsConfigurator(isSimpleDetailsViewActivated!= null? isSimpleDetailsViewActivated:false);
//
//      config.setAppendedPhraseActivated(isShowAppendedPhrase);
//      config.setAtomisedEpithetsActivated(isShowEpithets);
//      config.setAuthorshipSectionActivated(isShowAuthorship);
//      config.setAuthorCacheActivated(isShowAuthorCache);
//      config.setLSIDActivated(isShowLSID);
//      config.setNameApprobiationActivated(isShowNameApprobiation);
//      config.setNameCacheActivated(isShowNameCache);
//      config.setNameRelationsSectionActivated(isShowNameRelationship);
//      config.setNameRelationsRuleConsideredActivated(isNameRelationRuleConsideredActivated);
//      config.setNameRelationsRuleConsideredCodeEditionActivated(isNameRelationRuleConsideredCodeEditionActivated);
//      config.setNomenclaturalCodeActived(isShowNomenclaturalCode);
//      config.setNomenclaturalStatusSectionActivated(isShowNomenclaturalStatus);
//      config.setNomenclaturalStatusRuleConsideredActivated(isNomenclaturalStatusRuleConsideredActivated);
//      config.setNomenclaturalStatusRuleConsideredCodeEditionActivated(isNomenclaturalStatusRuleConsideredCodeEditionActivated);
//      config.setNomenclaturalReferenceSectionActivated(isShowNomenclaturalRef);
//      config.setProtologueActivated(isShowProtologue);
//      config.setRankActivated(isShowRank);
//      config.setTaxonSectionActivated(isShowTaxon);
//      config.setSecDetailsActivated(isSecDetailsActivated);
//      config.setSecEnabled(isSecEnabled);
//      config.setTypeDesignationSectionActivated(isShowTypeDesignation);
//      config.setHybridActivated(isShowHybrid);
//
//
//      return config;
//   }


    @Override
    public boolean performOk() {
        if (!isApply()){
            return true;
        }
        if (nameDetailsConfig == null){
            return true;
        }
        ICdmRepository controller = CdmStore.getCurrentApplicationConfiguration();
        if (controller == null){
            return false;
        }
        IPreferenceService service = controller.getPreferenceService();
        //NameDetailsConfigurator config = createNameDetailsViewConfig();
        String value = nameDetailsConfig.toString();

        if (nameDetailsConfig.isDefault() && isAllowOverride){
            service.remove(CdmPreference.NewKey(PreferenceSubject.NewTaxEditorInstance(), PreferencePredicate.NameDetailsView));

            return true;
        }
        CdmPreference pref = CdmPreference.NewTaxEditorInstance(PreferencePredicate.NameDetailsView, value);
        pref.setAllowOverride(isAllowOverride);
        service.set(pref);
        PreferencesUtil.updateDBPreferences();


        return true;
    }


    @Override
    public void getValues(){
        isAdminPreference = true;
        ICdmRepository controller = CdmStore.getCurrentApplicationConfiguration();
        if (controller != null){
            IPreferenceService service = controller.getPreferenceService();
            PrefKey key = CdmPreference.NewKey(PreferenceSubject.NewTaxEditorInstance(), PreferencePredicate.NameDetailsView);
            nameDetailsPref = service.find(key);
            if (nameDetailsPref != null) {
                isAllowOverride = nameDetailsPref.isAllowOverride();
                CdmPreferenceCache cache = CdmPreferenceCache.instance();
                cache.put(nameDetailsPref);
            }else {
                isAllowOverride = true;
            }


        }
        if (nameDetailsPref == null){
            nameDetailsConfig = new NameDetailsConfigurator();
        }else{
            nameDetailsConfig = PreferencesUtil.getPreferredNameDetailsConfiguration(false);
        }


    }




}
