/**
* Copyright (C) 2019 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.databaseAdmin.preferencePage;

import eu.etaxonomy.cdm.model.metadata.PreferencePredicate;
import eu.etaxonomy.cdm.model.term.TermType;
import eu.etaxonomy.taxeditor.preference.PreferencesUtil;
import eu.etaxonomy.taxeditor.preference.menu.NameFeatureMenuPreference;

/**
 * @author k.luther
 * @since 03.09.2019
 */
public class NameFeatureAdminMenuPreference extends NameFeatureMenuPreference {

    /**
     * <p>Constructor for NameFeatureMenuPreference.</p>
     */
    public NameFeatureAdminMenuPreference() {
        super();
        isAdminPreference = true;
        setPredicate(PreferencePredicate.NameFeatures);
        type = TermType.Feature;
    }

    @Override
    public boolean performOk() {
        if (!isApply()){
            return true;
        }
       boolean result = performOkAdmin();
       if (result){
           if (result){
               PreferencesUtil.createPreferredFeatureTreeForNameDescription();
           }
       }
       return result;
    }


}
