/**
* Copyright (C) 2019 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.databaseAdmin.preferencePage;

import eu.etaxonomy.cdm.model.metadata.CdmPreference;
import eu.etaxonomy.cdm.model.metadata.PreferencePredicate;
import eu.etaxonomy.cdm.model.term.TermType;
import eu.etaxonomy.taxeditor.preference.CdmPreferenceCache;
import eu.etaxonomy.taxeditor.preference.NamedAreaVocabularyPreferencePage;
import eu.etaxonomy.taxeditor.preference.PreferencesUtil;

/**
 * @author k.luther
 * @since 12.09.2019
 */
public class NamedAreaVocabularyAdminPreferencePage extends NamedAreaVocabularyPreferencePage {

    public NamedAreaVocabularyAdminPreferencePage(){
        isAdminPreference = true;
        setPredicate(PreferencePredicate.AvailableDistributionAreaVocabularies);
        type = TermType.NamedArea;

    }
    @Override
    public void getValues() {
       type = TermType.NamedArea;
       isAdminPreference = true;
       CdmPreferenceCache cache = CdmPreferenceCache.instance();
       cache.getAllTaxEditorDBPreferences();
       pref = PreferencesUtil.getPreferenceFromDB(PreferencePredicate.AvailableDistributionAreaVocabularies);
       if (pref == null){
           pref = CdmPreference.NewTaxEditorInstance(PreferencePredicate.AvailableDistributionAreaVocabularies, PreferencePredicate.AvailableDistributionAreaVocabularies.getDefaultValue() != null ?  PreferencePredicate.AvailableDistributionAreaVocabularies.getDefaultValue().toString(): null);
       }

    }

}
