/**
* Copyright (C) 2020 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.databaseAdmin.preferencePage;

import eu.etaxonomy.cdm.api.application.ICdmRepository;
import eu.etaxonomy.cdm.api.service.IPreferenceService;
import eu.etaxonomy.cdm.model.metadata.CdmPreference;
import eu.etaxonomy.taxeditor.preference.PreferencesUtil;
import eu.etaxonomy.taxeditor.preference.SecundumReferenceHandling;
import eu.etaxonomy.taxeditor.store.CdmStore;

/**
 * @author k.luther
 * @since Dec 1, 2020
 */
public class SecundumReferenceHandlingAdmin extends SecundumReferenceHandling {

    @Override
    public void init() {
        super.init();
        isAdminPreference = true;

    }



     @Override
     public boolean performOk() {
         if (!isApply()){
             return true;
         }
         ICdmRepository controller = CdmStore.getCurrentApplicationConfiguration();
         if (controller == null){
             return false;
         }
         IPreferenceService service = controller.getPreferenceService();
//         String textCombo = synonymSecundumBehaviour.getText();
         String text = secundumBehaviour != null? secundumBehaviour.getKey(): null;
         // default -> delete preference
         if(text == null && allowOverride){
             service.remove(pref.getKey());
             PreferencesUtil.updateDBPreferences();
             return true;
         }
//         }else if (textCombo.startsWith(Messages.Preference_Use_Default)){
//             text = null;
//         }else{
//             for (SecReferenceHandlingEnum display: SecReferenceHandlingEnum.values()){
//                 if (display.getLabel().equals(textCombo)){
//                     text = display.getKey();
//                     break;
//                 }
//             }
//         }
         CdmPreference preference = CdmPreference.NewInstance(pref.getKey(), text);
         preference.setAllowOverride(allowOverride);

         service.set(preference);

         text = secundumSwapBehaviour != null? secundumSwapBehaviour.getKey(): null;
         // default -> delete preference
         if(text == null && allowOverrideSwap){
             service.remove(prefSwap.getKey());
             PreferencesUtil.updateDBPreferences();
             return true;
         }

         CdmPreference preferenceSwap = CdmPreference.NewInstance(prefSwap.getKey(), text);
         preferenceSwap.setAllowOverride(allowOverrideSwap);

         service.set(preferenceSwap);
         PreferencesUtil.updateDBPreferences();

         return true;
     }



     @Override
     public void getValues() {
         super.getValues();
         isAdminPreference = true;


     }
}
