/**
* Copyright (C) 2019 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.databaseAdmin.preferencePage;

import eu.etaxonomy.cdm.model.metadata.CdmPreference;
import eu.etaxonomy.cdm.model.metadata.PreferencePredicate;
import eu.etaxonomy.taxeditor.preference.PreferencesUtil;
import eu.etaxonomy.taxeditor.preference.SupplementalDataSourcePreferences;

/**
 * @author k.luther
 * @since 28.06.2019
 *
 */
public class SupplementalDataSourceAdminPreference extends SupplementalDataSourcePreferences implements IE4AdminPreferencePage{

    private CdmPreference prefShowIdNamespace;
    private CdmPreference prefShowIdInSource;

    @Override
    public boolean performOk() {
        if (!isApply()){
            return true;
        }
        boolean setToDefault = false;
        if (isShowIDSource == null && isAllowOverrideShowIDSource){
            setToDefault = true;
        }

        CdmPreference pref = CdmPreference.NewTaxEditorInstance(PreferencePredicate.ShowIdInSource, isShowIDSource != null? Boolean.toString(this.isShowIDSource): null);
        pref.setAllowOverride(isAllowOverrideShowIDSource);
        PreferencesUtil.setPreferencesToDB(pref, setToDefault);
        setToDefault = false;
        if (isShowIDNamespace== null && isAllowOverrideShowIDNamespace){
            setToDefault = true;

        }
        pref = CdmPreference.NewTaxEditorInstance(PreferencePredicate.ShowNamespaceInSource, isShowIDNamespace != null? Boolean.toString(this.isShowIDNamespace): null);
        pref.setAllowOverride(isAllowOverrideShowIDNamespace);
        PreferencesUtil.setPreferencesToDB(pref, setToDefault);

        PreferencesUtil.updateDBPreferences();
        return true;
    }

    @Override
    protected void getValues(){
        isAdminPreference = true;

        prefShowIdNamespace = PreferencesUtil.getPreferenceFromDB(PreferencePredicate.ShowNamespaceInSource);
        if (prefShowIdNamespace == null){
            prefShowIdNamespace = CdmPreference.NewTaxEditorInstance(PreferencePredicate.ShowNamespaceInSource, null);
            prefShowIdNamespace.setAllowOverride(true);
        }
        isShowIDNamespace = prefShowIdNamespace.getValue()!= null? Boolean.parseBoolean(prefShowIdNamespace.getValue()): null;
        isAllowOverrideShowIDNamespace = prefShowIdNamespace.isAllowOverride();

        prefShowIdInSource = PreferencesUtil.getPreferenceFromDB(PreferencePredicate.ShowIdInSource);
        if (prefShowIdInSource == null){
            prefShowIdInSource = CdmPreference.NewTaxEditorInstance(PreferencePredicate.ShowIdInSource, null);
            prefShowIdInSource.setAllowOverride(true);
        }
        isShowIDSource = prefShowIdInSource.getValue()!= null? Boolean.parseBoolean(prefShowIdInSource.getValue()): null;
        isAllowOverrideShowIDSource = prefShowIdInSource.isAllowOverride();
    }
}
