/**
* Copyright (C) 2019 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.databaseAdmin.preferencePage;

import eu.etaxonomy.cdm.model.metadata.CdmPreference;
import eu.etaxonomy.cdm.model.metadata.PreferencePredicate;
import eu.etaxonomy.taxeditor.preference.NavigatorOrderEnum;
import eu.etaxonomy.taxeditor.preference.OrderPreferences;
import eu.etaxonomy.taxeditor.preference.PreferencesUtil;

/**
 * @author k.luther
 * @since 04.09.2019
 */
public class TaxonNodeOrderAdminPreference extends OrderPreferences {


    @Override
    public boolean performOk() {
        if (isApply()){
            orderPref = CdmPreference.NewTaxEditorInstance(PreferencePredicate.TaxonNodeOrder, this.orderActivated!=null?this.orderActivated.getKey():null);
            orderPref.setAllowOverride(allowOverride);
            PreferencesUtil.setPreferenceToDB(orderPref);
            nodePref = CdmPreference.NewTaxEditorInstance(PreferencePredicate.ShowTaxonNodeWizard, isShowTaxonNodeWizard != null? Boolean.toString(this.isShowTaxonNodeWizard): null);
            nodePref.setAllowOverride(isAllowOverrideShowTaxonNodeWizard);
            PreferencesUtil.setPreferenceToDB(nodePref);
            setApply(false);
        }
        return true;

    }

    @Override
    protected void getValues(){
        super.getValues();
        isAdminPreference = true;
       // orderPref = PreferencesUtil.getPreferenceFromDB(PreferencePredicate.TaxonNodeOrder);

       // allowOverride = orderPref != null? orderPref.isAllowOverride():true;
        if (orderPref == null){
            orderPref = CdmPreference.NewTaxEditorInstance(PreferencePredicate.TaxonNodeOrder, null);
        }
        orderActivated = orderPref.getValue() != null?NavigatorOrderEnum.valueOf(orderPref.getValue()): null;
        isShowTaxonNodeWizard = getBooleanPrefValue(nodePref);
    }




}
