/**
* Copyright (C) 2017 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.databaseAdmin.wizard;

import org.eclipse.jface.wizard.WizardPage;
import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.ScrolledComposite;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.TabFolder;
import org.eclipse.swt.widgets.TabItem;

/**
 * @author k.luther
 * @date 26.04.2017
 *
 */
public abstract class AbstractPreferenceWizard extends WizardPage {
    /**
     * @param pageName
     */
    protected AbstractPreferenceWizard(String pageName) {
        super(pageName);

    }
    protected TabFolder tabFolder;
    protected Composite composite;
    /***
     * Adds a tab to the page.
     * @param text the tab label
     */
     public Composite addTab(String text)    {
         if (tabFolder == null){
             // initialize tab folder
             if (composite == null) {
  //          	 composite = new ScrolledComposite(getShell(), SWT.BORDER | SWT.V_SCROLL);

//            	 Composite tabArea = new Composite(scroller, SWT.NONE); 
            	 composite = new Composite(getShell(), SWT.NONE);
             }
             tabFolder = new TabFolder(composite, SWT.NULL);
             tabFolder.setLayoutData(new GridData(GridData.FILL_BOTH));
         }

         TabItem item = new TabItem(tabFolder, SWT.NONE);
         item.setText(text);

         Composite currentTab = new Composite(tabFolder, SWT.NONE);
         GridLayout layout = new GridLayout();
         currentTab.setLayout(layout);
         currentTab.setFont(composite.getFont());
        // currentTab.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));

         item.setControl(currentTab);
         return currentTab;

     }

}
