/**
* Copyright (C) 2016 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.databaseAdmin.wizard;

import java.util.List;

import org.eclipse.jface.wizard.WizardPage;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;

import eu.etaxonomy.cdm.api.service.config.CacheUpdaterConfigurator;
import eu.etaxonomy.cdm.model.common.IdentifiableEntity;
import eu.etaxonomy.cdm.model.name.TaxonName;
import eu.etaxonomy.cdm.model.taxon.TaxonBase;
import eu.etaxonomy.taxeditor.l10n.Messages;

/**
 * @author k.luther
 * @date 13.12.2016
 *
 */
public class DatabaseRepairTitleCacheUpdatePage extends WizardPage {

    CacheUpdaterConfigurator config;

    /**
     * @param pageName
     * @param configTitleCache
     */
    protected DatabaseRepairTitleCacheUpdatePage(String pageName, CacheUpdaterConfigurator configTitleCache) {
        super(pageName);
        config = configTitleCache;

    }

    /**
     * {@inheritDoc}
     */
    @Override
    public void createControl(Composite parent) {
        final Composite composite = new Composite(parent, SWT.NULL);

        GridLayout gridLayout = new GridLayout();
        composite.setLayout(gridLayout);

        setControl(composite);

        Button checkBoxZoologicalName = new Button(composite, SWT.CHECK);
        checkBoxZoologicalName.setSelection(config.getClassList().contains(TaxonBase.class));
        checkBoxZoologicalName.setText(Messages.DatabaseRepairPage_TaxonBase);
        checkBoxZoologicalName
        .setToolTipText(Messages.DatabaseRepairPage_toolTip_taxonBase);
        checkBoxZoologicalName.addSelectionListener(new SelectionAdapter() {
            @Override
            public void widgetSelected(SelectionEvent e) {
                List<Class<? extends IdentifiableEntity>> classList  = config.getClassList();
                classList.add(TaxonBase.class);
            }
        });









                Button checkBoxTaxonName = new Button(composite, SWT.CHECK);
                checkBoxTaxonName.setSelection(config.getClassList().contains(TaxonName.class));
                checkBoxTaxonName.setText(Messages.DatabaseRepairPage_updateTaxonName);
                checkBoxTaxonName
                        .setToolTipText(Messages.DatabaseRepairPage_toolTip_TaxonName);
                checkBoxTaxonName.addSelectionListener(new SelectionAdapter() {
                    @Override
                    public void widgetSelected(SelectionEvent e) {
                        List<Class<? extends IdentifiableEntity>> classList = config.getClassList();
                        classList.add(TaxonName.class);
                    }
                });


    }

}
