/**
* Copyright (C) 2017 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.databaseAdmin.wizard;

import org.eclipse.jface.wizard.Wizard;

import eu.etaxonomy.taxeditor.io.e4.in.abcd.AbcdImportConfiguratorWizardPage;
import eu.etaxonomy.taxeditor.preference.PreferencesUtil;

/**
 * @author k.luther
 * @date 19.04.2017
 *
 */
public class ImportPreferencesWizard extends Wizard {

    public AbcdImportConfiguratorWizardPage configPage;

    public ImportPreferencesWizard() {
        setWindowTitle("Abcd Import Configuration Wizard");

        configPage = AbcdImportConfiguratorWizardPage.createPreferencePage(PreferencesUtil.getLastUsedAbcdImportConfigurator());

    }
    @Override
    public void addPages() {
        addPage(configPage);
    }
    /**
     * {@inheritDoc}
     */
    @Override
    public boolean performFinish() {
       this.configPage.saveConfigToPrefernceStore();
       return true;
    }



}
