/**
* Copyright (C) 2017 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.databaseAdmin.wizard;

import org.eclipse.jface.preference.IPreferenceStore;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;

import eu.etaxonomy.taxeditor.l10n.Messages;
import eu.etaxonomy.taxeditor.preference.NameDetailsConfigurator;
import eu.etaxonomy.taxeditor.preference.PreferencesUtil;

/**
 * @author k.luther
 * @date 22.02.2017
 *
 */
public class NameDetailsViewComposite extends Composite {

    NameDetailsConfigurator config;
    boolean isSimpleDetailsViewActivated;
    boolean isShowTaxon;
    boolean isShowLSID;
    boolean isShowNomenclaturalCode;
    boolean isShowNameCache;
    boolean isShowAppendedPhrase;
    boolean isShowRank;
    boolean isShowEpithets;
    boolean isShowAuthorshipCache;
    boolean isShowAuthorship;
    boolean isShowNomenclaturalRef;
    boolean isShowNomenclaturalStatus;
    boolean isShowProtologue;
    boolean isShowTypeDesignation;
    boolean isShowNameRelationship;
    boolean isShowHybrid;
    Composite child;
	private boolean isShowNameApprobiation;

    public NameDetailsViewComposite(Composite parent, int style, NameDetailsConfigurator config){

        super(parent, SWT.NONE);
//        TabItem tbtmNameDetailsConfiguration = new TabItem(tabFolder, SWT.NONE);
//        Composite c2 = new Composite(tabFolder, SWT.BORDER);
//        c2.setLayout(new GridLayout(1, true));
//        tbtmNameDetailsConfiguration.setControl(c2);
       // composite.setLayout(new GridLayout(1, true));
       this.config = config;

      // Composite composite = new Composite(parent, SWT.NULL);

       this.setLayout(new GridLayout());
       GridData data = new GridData(GridData.FILL_BOTH);
       this.setData(data);
//       CdmPreference pref = PreferencesUtil.getPreferenceFromDB(PreferencePredicate.NameDetailsView);
//       NameDetailsConfigurator config = PreferencesUtil.setPreferredNameDetailsConfiguration(local)

       final Button allowLocalPreference = new Button(this, SWT.CHECK);
//       boolean isUseLocalPreference = PreferencesUtil.getPreferenceStore().getBoolean(IPreferenceKeys.ALLOW_OVERRIDE_NAME_DETAILS);
//       allowLocalPreference.setText(Messages.DatabasePreferencesPage_UseLocalPreferences);
//       allowLocalPreference.setSelection(isUseLocalPreference);
//       allowLocalPreference.addSelectionListener(new SelectionAdapter(){
//            @Override
//            public void widgetSelected(SelectionEvent e) {
//                boolean isUseLocalPreference = allowLocalPreference.getSelection();
//                PreferencesUtil.getPreferenceStore().setValue(IPreferenceKeys.ALLOW_OVERRIDE_NAME_DETAILS, isUseLocalPreference);
//             }
//        });


//       isSimpleDetailsViewActivated= config.isSimpleDetailsViewActivated();
       final Button activateCheckButton = new Button(this, SWT.CHECK);
       activateCheckButton.setLayoutData(new GridData(SWT.LEFT, SWT.CENTER, true, true, 1, 1));
       activateCheckButton.setText(Messages.NameDetailsViewConfiguration_activateSimpleDetailsView);
       activateCheckButton.setSelection(isSimpleDetailsViewActivated);
       activateCheckButton.addSelectionListener(new SelectionAdapter(){
       @Override
       public void widgetSelected(SelectionEvent e) {
           isSimpleDetailsViewActivated = activateCheckButton.getSelection();
          //
           if(isSimpleDetailsViewActivated){
               child.setVisible(true);
               child.setEnabled(true);
           }else{
               child.setVisible(false);
               child.setEnabled(false);
           }
        }
        });

       child = new Composite(this, SWT.NULL);

       child.setLayout(new GridLayout());
       child.setVisible(isSimpleDetailsViewActivated);

       final Button showTaxon = new Button(child, SWT.CHECK);
       isShowTaxon = config.isTaxonSectionActivated();
       showTaxon.setText(Messages.NameDetailsViewComposite_Show_Taxon);
       showTaxon.setSelection(isShowTaxon);
       showTaxon.addSelectionListener(new SelectionAdapter(){
            @Override
            public void widgetSelected(SelectionEvent e) {
               isShowTaxon = showTaxon.getSelection();

             }
        });

       final Button showLsid = new Button(child, SWT.CHECK);
       isShowLSID = config.isLSIDActivated();
       showLsid.setText(Messages.NameDetailsViewComposite_Show_LSID);
       showLsid.setSelection(isShowLSID);
       showLsid.addSelectionListener(new SelectionAdapter(){
            @Override
            public void widgetSelected(SelectionEvent e) {
                isShowLSID = showLsid.getSelection();

             }
        });

       final Button showNomenclaturalCode = new Button(child, SWT.CHECK);
       isShowNomenclaturalCode = config.isNomenclaturalCodeActived();
       showNomenclaturalCode.setText(Messages.NameDetailsViewComposite_Show_NomenclaturalCode);
       showNomenclaturalCode.setSelection(isShowNomenclaturalCode);
       showNomenclaturalCode.addSelectionListener(new SelectionAdapter(){
            @Override
            public void widgetSelected(SelectionEvent e) {
                isShowNomenclaturalCode = showNomenclaturalCode.getSelection();

             }
        });

       final Button showNameCache = new Button(child, SWT.CHECK);
       isShowNameCache= config.isNameCacheActivated();

       showNameCache.setText(Messages.NameDetailsViewComposite_Show_NameCache);
       showNameCache.setSelection(isShowNomenclaturalCode);
       showNameCache.addSelectionListener(new SelectionAdapter(){
            @Override
            public void widgetSelected(SelectionEvent e) {
                isShowNameCache = showNameCache.getSelection();

             }
        });
       final Button showAppendedPhrase = new Button(child, SWT.CHECK);
       isShowAppendedPhrase= config.isAppendedPhraseActivated();
       showAppendedPhrase.setText(Messages.NameDetailsViewComposite_Show_AppendedPhrase);
       showAppendedPhrase.setSelection(isShowAppendedPhrase);
       showAppendedPhrase.addSelectionListener(new SelectionAdapter(){
            @Override
            public void widgetSelected(SelectionEvent e) {
                isShowAppendedPhrase = showAppendedPhrase.getSelection();

             }
        });

       final Button showRank = new Button(child, SWT.CHECK);
       isShowRank = config.isRankActivated();
       showRank.setText(Messages.NameDetailsViewComposite_Show_Rank);
       showRank.setSelection(isShowRank);
       showRank.addSelectionListener(new SelectionAdapter(){
            @Override
            public void widgetSelected(SelectionEvent e) {
                isShowRank = showRank.getSelection();
             }
        });
       final Button showEpithets = new Button(child, SWT.CHECK);
       isShowEpithets = config.isAtomisedEpithetsActivated();
       showEpithets.setText(Messages.NameDetailsViewComposite_Show_AtomisedEpithets);
       showEpithets.setSelection(isShowEpithets);
       showEpithets.addSelectionListener(new SelectionAdapter(){
            @Override
            public void widgetSelected(SelectionEvent e) {
                isShowEpithets = showEpithets.getSelection();
             }
        });
       final Button showAuthorshipCache = new Button(child, SWT.CHECK);
       isShowAuthorshipCache= config.isAuthorCacheActivated();
       showAuthorshipCache.setText(Messages.NameDetailsViewComposite_Show_AuthorCache);
       showAuthorshipCache.setSelection(isShowAuthorshipCache);
       showAuthorshipCache.addSelectionListener(new SelectionAdapter(){
            @Override
            public void widgetSelected(SelectionEvent e) {
                isShowAuthorshipCache = showAuthorshipCache.getSelection();
             }
        });

       final Button showAuthorship = new Button(child, SWT.CHECK);
       isShowAuthorship =config.isAuthorshipSectionActivated();
       showAuthorship.setText(Messages.NameDetailsViewComposite_Show_Author);
       showAuthorship.setSelection(isShowAuthorship);
       showAuthorship.addSelectionListener(new SelectionAdapter(){
            @Override
            public void widgetSelected(SelectionEvent e) {
                isShowAuthorship = showAuthorship.getSelection();
             }
        });

       final Button showNomenclaturalRef = new Button(child, SWT.CHECK);
       isShowNomenclaturalRef = config.isNomenclaturalReferenceSectionActivated();
       showNomenclaturalRef.setText(Messages.NameDetailsViewComposite_Show_NomenclaturalReference);
       showNomenclaturalRef.setSelection(isShowNomenclaturalRef);
       showNomenclaturalRef.addSelectionListener(new SelectionAdapter(){
            @Override
            public void widgetSelected(SelectionEvent e) {
                isShowNomenclaturalRef = showNomenclaturalRef.getSelection();
             }
        });

       final Button showNomenclaturalStatus = new Button(child, SWT.CHECK);
       isShowNomenclaturalStatus = config.isNomenclaturalStatusSectionActivated();
       showNomenclaturalStatus.setText(Messages.NameDetailsViewComposite_Show_NomenclaturalStatus);
       showNomenclaturalStatus.setSelection(isShowNomenclaturalStatus);
       showNomenclaturalStatus.addSelectionListener(new SelectionAdapter(){
            @Override
            public void widgetSelected(SelectionEvent e) {
                isShowNomenclaturalStatus = showNomenclaturalStatus.getSelection();
             }
        });

       final Button showProtologue = new Button(child, SWT.CHECK);
       isShowProtologue  = config.isProtologueActivated();
       showProtologue.setText(Messages.NameDetailsViewComposite_Show_Protologue);
       showProtologue.setSelection(isShowProtologue);
       showProtologue.addSelectionListener(new SelectionAdapter(){
            @Override
            public void widgetSelected(SelectionEvent e) {
                isShowProtologue = showProtologue.getSelection();
             }
        });

       final Button showTypeDesignation = new Button(child, SWT.CHECK);
       isShowTypeDesignation = config.isTypeDesignationSectionActivated();
       showTypeDesignation.setText(Messages.NameDetailsViewComposite_Show_TypeDesignation);
       showTypeDesignation.setSelection(isShowTypeDesignation);
       showTypeDesignation.addSelectionListener(new SelectionAdapter(){
            @Override
            public void widgetSelected(SelectionEvent e) {
                isShowTypeDesignation = showTypeDesignation.getSelection();
             }
        });


       final Button showNameRelationship = new Button(child, SWT.CHECK);
       isShowNameRelationship = config.isNameRelationsSectionActivated();
       showNameRelationship.setText(Messages.NameDetailsViewComposite_Show_Namerelationships);
       showNameRelationship.setSelection(isShowNameRelationship);
       showNameRelationship.addSelectionListener(new SelectionAdapter(){
            @Override
            public void widgetSelected(SelectionEvent e) {
                isShowNameRelationship = showNameRelationship.getSelection();
             }
        });

       final Button showHybrid = new Button(child, SWT.CHECK);
       isShowHybrid = config.isHybridActivated();
       showHybrid.setText(Messages.NameDetailsViewComposite_Show_Hybrid);
       showHybrid.setSelection(isShowHybrid);
       showHybrid.addSelectionListener(new SelectionAdapter(){
            @Override
            public void widgetSelected(SelectionEvent e) {
                isShowHybrid = showHybrid.getSelection();
             }
        });
       final Button showNameApprobiation = new Button(child, SWT.CHECK);
       isShowNameApprobiation = config.isNameApprobiationActivated();
       showNameApprobiation.setText(Messages.NameDetailsViewComposite_Show_NameApprobiation);
       showNameApprobiation.setSelection(isShowNameApprobiation);
       showNameApprobiation.addSelectionListener(new SelectionAdapter(){
            @Override
            public void widgetSelected(SelectionEvent e) {
            	isShowNameApprobiation = showNameApprobiation.getSelection();
             }
        });

       this.redraw();

       if(isSimpleDetailsViewActivated){
           child.setEnabled(true);
       }else{
           child.setEnabled(false);
       }

    }

    /**
    *
    */
   protected NameDetailsConfigurator createNameDetailsViewConfig() {


//      config.setSimpleDetailsViewActivated(isSimpleDetailsViewActivated);
      config.setAppendedPhraseActivated(isShowAppendedPhrase);
      config.setAtomisedEpithetsActivated(isShowEpithets);
      config.setAuthorshipSectionActivated(isShowAuthorship);
      config.setAuthorCacheActivated(isShowAuthorshipCache);
      config.setLSIDActivated(isShowLSID);
      config.setNameApprobiationActivated(isShowNameApprobiation);
      config.setNameCacheActivated(isShowNameCache);
      config.setNameRelationsSectionActivated(isShowNameRelationship);
      config.setNomenclaturalCodeActived(isShowNomenclaturalCode);
      config.setNomenclaturalStatusSectionActivated(isShowNomenclaturalStatus);
      config.setNomenclaturalReferenceSectionActivated(isShowNomenclaturalRef);
      config.setProtologueActivated(isShowProtologue);
      config.setRankActivated(isShowRank);
      config.setTaxonSectionActivated(isShowTaxon);
      config.setTypeDesignationSectionActivated(isShowTypeDesignation);
      config.setHybridActivated(isShowHybrid);


      return config;
   }


    protected IPreferenceStore doGetPreferenceStore() {
        return PreferencesUtil.getPreferenceStore();
    }

}
