/**
* Copyright (C) 2018 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.editor.definedterm;

import org.apache.commons.lang3.StringUtils;
import org.eclipse.jface.viewers.Viewer;
import org.eclipse.jface.viewers.ViewerComparator;

import eu.etaxonomy.cdm.common.CdmUtils;
import eu.etaxonomy.cdm.model.term.TermNode;
import eu.etaxonomy.cdm.persistence.dto.TermNodeDto;
import eu.etaxonomy.taxeditor.termtree.TermTreeLabelProvider;

/**
 * @author pplitzner
 * @since May 24, 2019
 */
public class TermTreeViewerComparator extends ViewerComparator {

    private TermTreeLabelProvider labelProvider = new TermTreeLabelProvider();

    @Override
    public int compare(Viewer viewer, Object e1, Object e2) {

        String label1 = "";
        String label2 = "";

        if (e1 instanceof TermNodeDto ){
            if (((TermNodeDto)e1).getTree().isOrderRelevant()){
                return 0;
            }
        }else if (e1 instanceof TermNode){
            if (((TermNode)e1).getGraph().isOrderRelevant()){
                return 0;
            }
        }

        if (StringUtils.isBlank(label1)){
            label1 = labelProvider.getText(e1);
        }
        if (StringUtils.isBlank(label2)){
            label2 = labelProvider.getText(e2);
        }

        //compare
        return CdmUtils.Nz(label1).toLowerCase().compareTo(CdmUtils.Nz(label2).toLowerCase());
    }
}
