/**
* Copyright (C) 2009 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.editor.definedterm.e4;

import java.util.List;

import org.eclipse.jface.util.LocalSelectionTransfer;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.viewers.TreeSelection;
import org.eclipse.jface.viewers.Viewer;
import org.eclipse.swt.dnd.DragSourceAdapter;
import org.eclipse.swt.dnd.DragSourceEvent;

import eu.etaxonomy.cdm.persistence.dto.TermDto;
import eu.etaxonomy.taxeditor.editor.definedterm.TermTransfer;

/**
 *
 * @author pplitzner
 * @since Aug 22, 2017
 *
 */
public class DefinedTermDragListenerE4 extends DragSourceAdapter {

	private Viewer viewer;

	public DefinedTermDragListenerE4(Viewer viewer) {
		this.viewer = viewer;
	}

	@Override
	public void dragStart(DragSourceEvent event) {
	    IStructuredSelection selection = (IStructuredSelection) viewer.getSelection();
	    List list = selection.toList();
	    for (Object object : list) {
            if(!(object instanceof TermDto)){
                event.doit = false;
                return;
            }
        }
		event.doit = true;
	}

	@Override
	public void dragFinished(DragSourceEvent event) {
	    super.dragFinished(event);
	    LocalSelectionTransfer.getTransfer().setSelection(null);
	}

	@Override
	public void dragSetData(DragSourceEvent event) {
	    IStructuredSelection selection = (IStructuredSelection) viewer.getSelection();
        if (LocalSelectionTransfer.getTransfer().isSupportedType(event.dataType)) {
            LocalSelectionTransfer.getTransfer().setSelection(selection);
            if (selection.getFirstElement() instanceof TermDto){
                TermTransfer.getInstance().setSelection((TermDto)selection.getFirstElement());
            }
        }

        if(selection!=null && !selection.isEmpty()){
            if (selection instanceof TreeSelection && ((TreeSelection)selection).getFirstElement() instanceof TermDto){
                TermDto[] featureNodes = (TermDto[]) selection.toList().toArray(new TermDto[selection.size()]);

                    event.data = featureNodes;
            }
        }

	}

}
