/**
 * Copyright (C) 2009 EDIT
 * European Distributed Institute of Taxonomy
 * http://www.e-taxonomy.eu
 *
 * The contents of this file are subject to the Mozilla Public License Version 1.1
 * See LICENSE.TXT at the top of this package for the full license terms.
 */
package eu.etaxonomy.taxeditor.editor.definedterm.e4.handler;

import javax.inject.Named;

import org.eclipse.core.commands.operations.IUndoContext;
import org.eclipse.e4.core.di.annotations.Execute;
import org.eclipse.e4.ui.di.UISynchronize;
import org.eclipse.e4.ui.model.application.ui.basic.MPart;
import org.eclipse.e4.ui.model.application.ui.menu.MMenuItem;
import org.eclipse.e4.ui.services.IServiceConstants;

import eu.etaxonomy.taxeditor.editor.definedterm.e4.DefinedTermEditorE4;
import eu.etaxonomy.taxeditor.editor.definedterm.operation.CreateTermVocabularyOperation;
import eu.etaxonomy.taxeditor.model.AbstractUtility;
import eu.etaxonomy.taxeditor.operation.AbstractPostOperation;
import eu.etaxonomy.taxeditor.store.StoreUtil;

/**
 *
 * @author pplitzner
 * @since Aug 22, 2017
 *
 */
public class CreateTermVocabularyHandlerE4 {

    @Execute
    public void execute(@Named(IServiceConstants.ACTIVE_PART) MPart activePart,
            MMenuItem menuItem,
            UISynchronize sync) {
        DefinedTermEditorE4 termEditor = (DefinedTermEditorE4) activePart.getObject();
        if(StoreUtil.promptCheckIsDirty(termEditor)){
            return;
        }
        String label = menuItem.getLocalizedLabel();
        IUndoContext undoContext = StoreUtil.getUndoContext();

        AbstractPostOperation operation =
                new CreateTermVocabularyOperation(label,
                        undoContext,
                        termEditor.getDefinedTermEditorInput(),
                        termEditor);
        AbstractUtility.executeOperation(operation, sync);
    }
}
