/**
* Copyright (C) 2019 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.handler;

import org.eclipse.e4.core.di.annotations.Execute;
import org.eclipse.jface.wizard.WizardDialog;

import eu.etaxonomy.taxeditor.databaseAdmin.wizard.DatabaseRepairUpdateSortIndicesWizard;
import eu.etaxonomy.taxeditor.model.AbstractUtility;

/**
 * @author k.luther
 * @since 05.03.2019
 *
 */
public class OpenUpdateSortIndicesHandler {

    @Execute
    public Object execute(){
        DatabaseRepairUpdateSortIndicesWizard databaseRepairWizard = new DatabaseRepairUpdateSortIndicesWizard();
        WizardDialog dialog = new WizardDialog(AbstractUtility.getShell(),
                databaseRepairWizard);

        dialog.open();

        return null;
    }


}
