/**
* Copyright (C) 2020 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.handler.defaultHandler.e4;

import java.util.List;

import org.eclipse.e4.ui.workbench.modeling.EPartService;
import org.eclipse.swt.widgets.Shell;

import eu.etaxonomy.cdm.model.common.ICdmBase;
import eu.etaxonomy.cdm.persistence.dto.UuidAndTitleCache;

/**
 * @author k.luther
 * @since Feb 20, 2020
 */
public abstract class DefaultOpenSetBaseHandler<S extends ICdmBase, T extends UuidAndTitleCache<S>>
            extends DefaultOpenHandlerBaseE4<S, T> {

    @Override
    protected void handleUuidList(Shell shell, EPartService partService, List<T> uuidList) throws Exception {
        open(uuidList, shell, partService);
    }

    protected abstract void open(List<T> uuidList, Shell shell, EPartService partService);

    @Override
    protected void open(T entity, Shell shell, EPartService partService) throws Exception {
        //nothing to do
    }

    @Override
    public boolean canExecuteHandleList(List<T> uuidList) {
        boolean canExecute = false;
        for (T uuid : uuidList){
            canExecute &= canExecute(uuid);
        }
        return canExecute;
    }
}