/**
* Copyright (C) 2018 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.handler.e4;

import javax.inject.Named;

import org.eclipse.e4.core.di.annotations.Execute;
import org.eclipse.e4.ui.services.IServiceConstants;
import org.eclipse.jface.wizard.WizardDialog;
import org.eclipse.swt.widgets.Shell;

import eu.etaxonomy.cdm.model.metadata.CdmPreference;
import eu.etaxonomy.cdm.model.metadata.PreferencePredicate;
import eu.etaxonomy.taxeditor.l10n.Messages;
import eu.etaxonomy.taxeditor.preference.PreferencesUtil;
import eu.etaxonomy.taxeditor.preference.wizard.AvailableVocabularyWizard;

/**
 * @author k.luther
 * @since 08.10.2018
 *
 */
public class OpenCommonNameAreaWizardAdminHandler {
    String commandID = "eu.etaxonomy.taxeditor.handler.e4.OpenCommonNameAreaWizardAdminHandler"; //$NON-NLS-1$

    @Execute
    public void execute(@Named(IServiceConstants.ACTIVE_SHELL)Shell shell) {
        CdmPreference pref = PreferencesUtil.getPreferenceFromDB(PreferencePredicate.CommonNameAreaVocabularies);
        if (pref == null){
            pref = CdmPreference.NewTaxEditorInstance(PreferencePredicate.CommonNameAreaVocabularies, null);
        }
        AvailableVocabularyWizard wizard = new AvailableVocabularyWizard(false, pref, Messages.OpenCommonNameAreaWizardAdminHandler_COMMON_NAMES);

        WizardDialog dialog = new WizardDialog(shell,
                wizard);

        dialog.open();
    }
}
