/**
* Copyright (C) 2019 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.handler.e4;

import javax.inject.Named;

import org.eclipse.e4.core.di.annotations.Execute;
import org.eclipse.e4.ui.services.IServiceConstants;
import org.eclipse.jface.wizard.WizardDialog;
import org.eclipse.swt.widgets.Shell;

import eu.etaxonomy.cdm.model.metadata.CdmPreference;
import eu.etaxonomy.cdm.model.metadata.PreferencePredicate;
import eu.etaxonomy.taxeditor.preference.PreferencesUtil;
import eu.etaxonomy.taxeditor.preference.wizard.AvailableDistributionWizard;

/**
 * @author k.luther
 * @since 24.04.2019
 *
 */
public class OpenDistributionAreaWizardHandler {
    String commandID = "eu.etaxonomy.taxeditor.handler.e4.OpenDistributionAreaWizardHandler"; //$NON-NLS-1$

    @Execute
    public void execute(@Named(IServiceConstants.ACTIVE_SHELL)Shell shell) {
        CdmPreference pref = CdmPreference.NewTaxEditorInstance(PreferencePredicate.AvailableDistributionAreaTerms, null);
        pref.setAllowOverride(PreferencesUtil.getBooleanValue(PreferencesUtil.prefOverrideKey(PreferencePredicate.AvailableDistributionAreaTerms.getKey())));
        AvailableDistributionWizard wizard = new AvailableDistributionWizard();

        WizardDialog dialog = new WizardDialog(shell,
                wizard);

        dialog.open();
    }
}
