/**
* Copyright (C) 2018 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.handler.e4;

import javax.inject.Named;

import org.eclipse.e4.core.di.annotations.Execute;
import org.eclipse.e4.ui.services.IServiceConstants;
import org.eclipse.jface.wizard.WizardDialog;
import org.eclipse.swt.widgets.Shell;

import eu.etaxonomy.taxeditor.preference.wizard.AvailableDistributionPerAreaStatusWizard;

/**
 * @author k.luther
 * @since 19.11.2018
 */
public class OpenDistributionPerAreaStatusWizardHandler {

    String commandID = "eu.etaxonomy.taxeditor.handler.e4.OpenDistributionPerAreaStatusWizardHandler";

    @Execute
    public void execute(@Named(IServiceConstants.ACTIVE_SHELL)Shell shell) {
        AvailableDistributionPerAreaStatusWizard wizard = new AvailableDistributionPerAreaStatusWizard(false);
        WizardDialog dialog = new WizardDialog(shell, wizard);
        dialog.open();
    }
}