/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.handler.e4;

import javax.inject.Named;

import org.eclipse.e4.core.di.annotations.Execute;
import org.eclipse.e4.ui.services.IServiceConstants;
import org.eclipse.jface.wizard.WizardDialog;
import org.eclipse.swt.widgets.Shell;

import eu.etaxonomy.cdm.model.permission.User;
import eu.etaxonomy.taxeditor.model.MessagingUtils;
import eu.etaxonomy.taxeditor.store.CdmStore;
import eu.etaxonomy.taxeditor.ui.password.PasswordWizard;

/**
 * @author pplitzner
 * @date 10.10.2017
 */
public class OpenPasswordWizzardHandlerE4 {

    @Execute
    public void execute(@Named(IServiceConstants.ACTIVE_SHELL)Shell shell) {

	    Object principal = CdmStore.getCurrentAuthentiation().getPrincipal();

	    if(principal instanceof User){

	        PasswordWizard wizard = new PasswordWizard((User)principal, null);
	        WizardDialog dialog = new WizardDialog(shell, wizard);

	        dialog.open();

	    } else {
	        // should never happen, log an error
	        MessagingUtils.error(OpenPasswordWizzardHandlerE4.class, "The principal currently authenticated is not a eu.etaxonomy.cdm.model.common.User", null);
	    }
	}
}
