/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.io.e4.in;

import javax.inject.Inject;

import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;

/**
 * @author pplitzner
 * @since Oct 5, 2017
 */
public class ImportFromFileDataSourceWithReferenceWizardPage extends ImportFromFileDataSourceWizardPage {

	private Text textReferenceString;

    @Inject
	public ImportFromFileDataSourceWithReferenceWizardPage() {
        super();
	}

	@Override
    public void createControl(Composite parent) {
		super.createControl(parent);

		Label labelRef = new Label(composite, SWT.NONE);
		labelRef.setText("Default import source reference");
        new Label(composite, SWT.NONE);
        textReferenceString = new Text(composite, SWT.NONE);
        textReferenceString.setEnabled(true);
        textReferenceString.setLayoutData(new GridData(SWT.FILL, SWT.TOP, true, true, 1, 1));
		new Label(composite, SWT.NONE);
	}

	public Text getTextReferenceString() {
		return textReferenceString;
	}

	public void setTextReferenceString(Text textReferenceString) {
		this.textReferenceString = textReferenceString;
	}
}