/**
 *
 */
package eu.etaxonomy.taxeditor.io.e4.in.excel.specimen;

import eu.etaxonomy.cdm.common.URI;
import java.util.ArrayList;
import java.util.List;

import javax.inject.Inject;

import org.eclipse.e4.core.contexts.ContextInjectionFactory;
import org.eclipse.e4.core.contexts.IEclipseContext;
import org.eclipse.e4.ui.workbench.modeling.EPartService;

import eu.etaxonomy.cdm.database.DbSchemaValidation;
import eu.etaxonomy.cdm.io.specimen.excel.in.SpecimenCdmExcelImportConfigurator;
import eu.etaxonomy.taxeditor.io.e4.in.AbstractImportWizardE4;
import eu.etaxonomy.taxeditor.io.e4.in.GenericConfiguratorWizardPageE4;
import eu.etaxonomy.taxeditor.io.e4.in.ImportFromFileDataSourceWithReferenceWizardPage;
import eu.etaxonomy.taxeditor.l10n.Messages;
import eu.etaxonomy.taxeditor.store.CdmStore;

/**
 *
 * @author pplitzner
 * @since Oct 5, 2017
 *
 */
public class SpecimenCdmExcelImportWizardE4 extends AbstractImportWizardE4<SpecimenCdmExcelImportConfigurator> {


    private SpecimenCdmExcelImportConfigurator configurator;

	private ImportFromFileDataSourceWithReferenceWizardPage dataSourcePage;

	@Inject
	public SpecimenCdmExcelImportWizardE4(IEclipseContext context, EPartService partService) {
	    super(context, partService);
	}

	@Override
	public SpecimenCdmExcelImportConfigurator getConfigurator() {
		return configurator;
	}

	/** {@inheritDoc} */
	@Override
    public void init() {
		configurator =  CdmStore.getImportManager().SpecimenCdmExcelImportConfigurator();
	}

	@Override
	public boolean performFinish() {
		URI source = dataSourcePage.getUri();
		configurator.setSource(source);
		configurator.setDbSchemaValidation(DbSchemaValidation.CREATE);

		CdmStore.getImportManager().run(configurator);

		return true;
	}

	/** {@inheritDoc} */
	@Override
	public void addPages() {
		dataSourcePage = ContextInjectionFactory.make(ImportFromFileDataSourceWithReferenceWizardPage.class, context);
        dataSourcePage.setTitle("Choose Specimen CDM Excel");
        dataSourcePage.setDescription("Please choose an xls file in the SpecimenCdmExcel format.");
        dataSourcePage.setExtensions(new String[]{"*.xlsx", "*.xls", "*.*"});

		addPage(dataSourcePage);
		super.addPages();
	}

	 @Override
	 protected void addConfiguratorPage(){
	     List<String> ignoreMethods = new ArrayList<>();
         ignoreMethods.add("setIgnoreNull");
         ignoreMethods.add("setInteractWithUser");
         ignoreMethods.add("setUseClassification");
         ignoreMethods.add("setRegisterAuditing");
         ignoreMethods.add("setDeduplicateAuthors");
         ignoreMethods.add("setDeduplicateReferences");
         pageConfiguration = ContextInjectionFactory.make(GenericConfiguratorWizardPageE4.class, context);
         pageConfiguration.initImport(getConfigurator(), ignoreMethods, Messages.ExcelSpecimenUpdateWizard_ConfiguratorWizard_label);
         addPage(pageConfiguration);
    }

}
