/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.io.e4.in.owl;

import javax.inject.Inject;

import org.eclipse.jface.wizard.WizardPage;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;

import eu.etaxonomy.cdm.io.descriptive.owl.in.StructureTreeOwlImportConfigurator;

/**
 *
 * @author pplitzner
 * @since Apr 25, 2019
 *
 */
public class OwlImportConfiguratorWizardPage extends WizardPage {

	public static final String PAGE_NAME = "StructureTreeOwlImportConfiguratorWizardPage";

	private StructureTreeOwlImportConfigurator configurator;

	@Inject
	public OwlImportConfiguratorWizardPage() {
        super(PAGE_NAME);
        setTitle("Configure import parameters");
        setDescription("Tooltips will explain parameters in more detail");
    }

	@Override
    public void createControl(Composite parent) {
		final Composite composite = new Composite(parent, SWT.NULL);
		GridLayout gridLayout = new GridLayout();
		composite.setLayout(gridLayout);

		setControl(composite);
	}

	 public String createConfigString(){
	    return configurator.toString();
	 }

    public void setConfigurator(StructureTreeOwlImportConfigurator configurator) {
        this.configurator = configurator;
    }

}
