/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.io.e4.out;

import org.eclipse.e4.core.contexts.ContextInjectionFactory;
import org.eclipse.e4.core.contexts.IEclipseContext;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.wizard.Wizard;

import eu.etaxonomy.cdm.io.common.IIoConfigurator;
import eu.etaxonomy.taxeditor.io.e4.in.GenericConfiguratorWizardPageE4;

/**
 * @author pplitzner
 * @since Oct 6, 2017
 */
public abstract class AbstractExportWizardE4<CONFIG extends IIoConfigurator> extends Wizard {

	protected final String CONFIGURATION_PAGE = "CONFIGURATION_PAGE";

	private GenericConfiguratorWizardPageE4 pageConfiguration;

    protected IStructuredSelection selection;

    private IEclipseContext context;

    public AbstractExportWizardE4(IEclipseContext context) {
        this(context, null);
    }

    public AbstractExportWizardE4(IEclipseContext context, IStructuredSelection selection) {
        this.context = context;
        this.selection = selection;
    }

	@Override
	public void addPages() {
		super.addPages();

		pageConfiguration = ContextInjectionFactory.make(GenericConfiguratorWizardPageE4.class, context);
		pageConfiguration.initExport(getConfigurator(), null);
		this.addPage(pageConfiguration);
	}

	public abstract void init();

	public abstract CONFIG getConfigurator();
}