package eu.etaxonomy.taxeditor.io.e4.out.csv.print;

import java.io.File;

import javax.inject.Inject;
import javax.inject.Named;

import org.eclipse.e4.core.contexts.IEclipseContext;
import org.eclipse.e4.core.di.annotations.Optional;
import org.eclipse.e4.ui.services.IServiceConstants;
import org.eclipse.jface.viewers.IStructuredSelection;

import eu.etaxonomy.cdm.filter.TaxonNodeFilter;
import eu.etaxonomy.cdm.io.common.ExportResultType;
import eu.etaxonomy.cdm.io.csv.caryophyllales.out.CsvNameExportConfigurator;
import eu.etaxonomy.taxeditor.io.e4.out.csv.name.CsvNameExportWizardE4;
import eu.etaxonomy.taxeditor.io.wizard.ExportToFileDestinationWizardPage;
import eu.etaxonomy.taxeditor.store.CdmStore;

public class CsvPrintExportWizardE4 extends CsvNameExportWizardE4{

    @Inject
    public CsvPrintExportWizardE4(IEclipseContext context,
            @Optional@Named(IServiceConstants.ACTIVE_SELECTION)IStructuredSelection selection) {
        super(context, selection);
    }

	@Override
	public void init() {
		configurator = CsvNameExportConfigurator.NewInstance(null,null);
		configurator.setNamesOnly(false);
		configurator.setCondensedDistribution(true);
	}

	@Override
	public CsvNameExportConfigurator getConfigurator() {
		return configurator;
	}

	@Override
	public void addPages() {
	    //TODO create page with drop down menu for export for single classification.
//		super.addPages();


		//standard page
		page =  ExportToFileDestinationWizardPage.CsvPrint(configurator);

		addPage(page);
	}

	@Override
	public boolean performFinish() {
		String urlString = page.getFolderText() + File.separator
				+ page.getExportFileName();

	    configurator.setTaxonNodeFilter(TaxonNodeFilter.NewClassificationInstance(page.getSelectedClassificationUUID()));
	    configurator.setResultType(ExportResultType.BYTE_ARRAY);

	    CdmStore.getExportManager().runMoniteredOperation(configurator, urlString);
		return true;
	}

}
