/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.io.wizard;

import java.io.File;

import javax.inject.Inject;

import org.eclipse.e4.core.contexts.IEclipseContext;
import org.eclipse.e4.ui.workbench.modeling.EPartService;

import eu.etaxonomy.cdm.common.URI;
import eu.etaxonomy.cdm.io.reference.endnote.in.EndnoteImportConfigurator;
import eu.etaxonomy.taxeditor.io.e4.in.AbstractImportWizardE4;
import eu.etaxonomy.taxeditor.io.e4.in.ImportFromFileDataSourceWizardPage;
import eu.etaxonomy.taxeditor.store.CdmStore;

/**
 * <p>EndnoteImportWizard class.</p>
 *
 * @author n.hoffmann
 * @created Sep 18, 2009
 */
public class EndnoteImportWizard extends AbstractImportWizardE4<EndnoteImportConfigurator>  {

	private EndnoteImportConfigurator configurator;

	private ImportFromFileDataSourceWizardPage dataSourcePage;

	@Inject
    public EndnoteImportWizard(IEclipseContext context, EPartService partService) {
        super(context, partService);
    }

	@Override
	public boolean performFinish() {

		File file = dataSourcePage.getFile();
		configurator.setSource(URI.fromFile(file));

		CdmStore.getImportManager().run(configurator);

		return true;
	}

	@Override
	public void addPages() {
		super.addPages();

		dataSourcePage = new ImportFromFileDataSourceWizardPage();
		addPage(dataSourcePage);
	}

	@Override
    public void init() {
		configurator =  CdmStore.getImportManager().EndnoteConfigurator();
	}

	@Override
	public EndnoteImportConfigurator getConfigurator() {
		return configurator;
	}



}