/**
 *
 */
package eu.etaxonomy.taxeditor.labels;

import java.util.List;

import org.eclipse.swt.graphics.Image;

import eu.etaxonomy.cdm.model.name.NameRelationshipType;
import eu.etaxonomy.taxeditor.model.ImageResources;
import eu.etaxonomy.taxeditor.store.TermStore;

/**
 * <p>DefaultLabelStrategy class.</p>
 *
 * @author p.ciardelli
 */
public class DefaultLabelStrategy implements ILabelImageStrategy {

	@Override
    public String getNameRelationTypeLabel(NameRelationshipType type) {
		List<NameRelationshipType> vocab =
			TermStore.getTerms(NameRelationshipType.class);

		for (NameRelationshipType type1 : vocab) {
			if (type1.equals(type)) {
				return type1.getLabel();
			}
		}
		return "";
	}

	@Override
    public String getNameRelationTypeInverseLabel(NameRelationshipType type) {

		List<NameRelationshipType> vocab =
			TermStore.getTerms(NameRelationshipType.class);

		for (NameRelationshipType type1 : vocab) {
			if (type1.equals(type)) {
				return type1.getInverseLabel();
			}
		}
		return "";
	}

	@Override
    public Image getNameRelationTypeImage(NameRelationshipType type) {
		if (NameRelationshipType.BASIONYM().equals(type)) {
			return ImageResources.getImage(
					ImageResources.BASIONYM_ICON);
		}
		if (NameRelationshipType.ORTHOGRAPHIC_VARIANT().equals(type)) {
			return ImageResources.getImage(
					ImageResources.ORTHOGRAPHIC_VARIANT_ICON);
		}
		return null;
	}

	@Override
    public String getNameRelationTypeDescription(NameRelationshipType type) {
		if (NameRelationshipType.BASIONYM().equals(type)) {
			return "Basionym";
		}
		return type.getDescription();
	}
}
