/**
 *
 */
package eu.etaxonomy.taxeditor.labels;

import org.eclipse.swt.graphics.Image;

import eu.etaxonomy.cdm.model.name.NameRelationshipType;

/**
 * <p>ZoologicalNameLabelStrategy class.</p>
 *
 * @author p.ciardelli
 */
public class ZoologicalNameLabelStrategy extends DefaultLabelStrategy {

	@Override
    public String getNameRelationTypeLabel(NameRelationshipType type) {
		if (type.equals(NameRelationshipType.BASIONYM())) {
			return "original combination for";
		}
		return super.getNameRelationTypeLabel(type);
	}

	@Override
    public Image getNameRelationTypeImage(NameRelationshipType type) {
		if (NameRelationshipType.BASIONYM().equals(type)) {
			return null;
		}
		return super.getNameRelationTypeImage(type);
	}

	@Override
    public String getNameRelationTypeDescription(NameRelationshipType type) {
		if (NameRelationshipType.BASIONYM().equals(type)) {
			return "Original Combination";
		}
		return super.getNameRelationTypeDescription(type);
	}
}
