/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.model;

import org.eclipse.jface.resource.FontRegistry;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.graphics.FontData;

import eu.etaxonomy.taxeditor.preference.Resources;

/**
 *
 * @author pplitzner
 * @since Nov 1, 2017
 *
 */
public class FontResources {

	private static FontResources instance;

	public static FontResources getInstance(){
		if(instance == null){
			instance = new FontResources();
		}
		return instance;
	}

	private static FontRegistry fontRegistry;

	public FontRegistry getFontRegistry() {
        if (fontRegistry == null) {
            fontRegistry = new FontRegistry();
            initializeFontRegistry(fontRegistry);
        }
        return fontRegistry;
    }

	public static Font getFont(String key){
	    return getInstance().getFontRegistry().get(key);
	}

	protected void initializeFontRegistry(FontRegistry registry) {
	    registerFont(registry, Resources.ACCEPTED_TAXON_FONT, "Georgia", 12, SWT.NORMAL);
	    registerFont(registry, Resources.SYNONYM_FONT, "Georgia", 10, SWT.NORMAL);
	    registerFont(registry, Resources.MISAPPLIEDNAME_FONT, "Georgia", 10, SWT.NORMAL);
	    registerFont(registry, Resources.CONCEPT_FONT, "Georgia", 10, SWT.NORMAL);
	    registerFont(registry, Resources.FONT_DEFAULT_PROMPT, "Georgia", 10, SWT.NORMAL);
		registerFont(registry, Resources.FONT_SEARCH_VIEW_ACCEPTED, "Arial", 10, SWT.NORMAL);
		registerFont(registry, Resources.FONT_SEARCH_VIEW_SYNONYM, "Arial", 10, SWT.ITALIC);
		registerFont(registry, Resources.FONT_SEARCH_VIEW_OTHER, "Lucida Grande", 11, SWT.NORMAL);
	}

    private void registerFont(FontRegistry registry, String key, String name, int height, int style) {
        registry.put(key, new FontData[]{new FontData(name, height, style)});
    }
}
