/**
 * Copyright (C) 2007 EDIT
 * European Distributed Institute of Taxonomy
 * http://www.e-taxonomy.eu
 *
 * The contents of this file are subject to the Mozilla Public License Version 1.1
 * See LICENSE.TXT at the top of this package for the full license terms.
 */

package eu.etaxonomy.taxeditor.model;

/**
 *
 * Clients implementing this interface indicate, that the data they present is
 * suitable for the media view and that the media view should handle selection
 * from the implementing part.
 *
 * @author pplitzner
 * @date Sep 16, 2014
 *
 */
public interface IPartContentHasMedia {

    /**
     * Return <code>true</code> if media can be attached to the editor input and
     * <code>false</code> otherwise
     *
     * @return true or false depending on the input of the implementing part
     */
    public boolean canAttachMedia();

}
