/**
 * Copyright (C) 2007 EDIT
 * European Distributed Institute of Taxonomy 
 * http://www.e-taxonomy.eu
 * 
 * The contents of this file are subject to the Mozilla Public License Version 1.1
 * See LICENSE.TXT at the top of this package for the full license terms.
 */

package eu.etaxonomy.taxeditor.model;

import eu.etaxonomy.cdm.hibernate.HibernateProxyHelper;

/**
 * 
 * @author n.hoffmann
 * @created Mar 30, 2011
 * @version 1.0
 */
public class PolytomousKeyRelationship {
	private Object destination;
	private Object source;

	public PolytomousKeyRelationship(Object source, Object destination) {
		this.source = HibernateProxyHelper.deproxy(source);
		this.destination = HibernateProxyHelper.deproxy(destination);
	}

	/**
	 * @param destination
	 *            the destination to set
	 */
	public void setDestination(Object destination) {
		this.destination = destination;
	}

	/**
	 * @return the destination
	 */
	public Object getDestination() {
		return destination;
	}

	/**
	 * @param source
	 *            the source to set
	 */
	public void setSource(Object source) {
		this.source = source;
	}

	/**
	 * @return the source
	 */
	public Object getSource() {
		return source;
	}
}
