/**
* Copyright (C) 2018 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.newWizard;

import eu.etaxonomy.cdm.api.service.IReferenceService;
import eu.etaxonomy.cdm.model.common.Marker;
import eu.etaxonomy.cdm.model.common.MarkerType;
import eu.etaxonomy.cdm.model.reference.ReferenceType;
import eu.etaxonomy.taxeditor.store.CdmStore;

/**
 * @author k.luther
 * @since 28.09.2018
 *
 */
public class NewCommonNameReferenceWizard extends NewReferenceWizard {


    /**
     * @param type
     */
    public NewCommonNameReferenceWizard(ReferenceType type) {
        super(type);
    }

    @Override
    protected void saveEntity() {
        getEntity().addMarker(Marker.NewInstance(MarkerType.COMMON_NAME_REFERENCE(), true));
        CdmStore.getService(IReferenceService.class).save(getEntity());
    }
}
