/**
* Copyright (C) 2014 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.newWizard;

import eu.etaxonomy.cdm.api.service.IVocabularyService;
import eu.etaxonomy.cdm.model.term.DefinedTermBase;
import eu.etaxonomy.cdm.model.term.TermType;
import eu.etaxonomy.cdm.model.term.TermVocabulary;
import eu.etaxonomy.taxeditor.store.CdmStore;

/**
 * @author pplitzner
 * @date 11.03.2014
 *
 */
public class NewFeatureVocabularyWizard  extends AbstractNewEntityWizard<TermVocabulary> {

    private VocabularyWizardPage vocabularyPage;

    private TermType termType;

    public NewFeatureVocabularyWizard(TermType termType) {
        this.termType = termType;
    }

    @Override
    public void addPages() {
        vocabularyPage = new VocabularyWizardPage(formFactory, getConversationHolder(), getEntity());
        addPage(vocabularyPage);
    }

    @Override
    protected TermVocabulary createNewEntity() {
        if(termType!=null){
            return TermVocabulary.NewInstance(termType);
        }
        return TermVocabulary.NewInstance(TermType.Feature);
    }

    @Override
    protected void saveEntity() {
       CdmStore.getService(IVocabularyService.class).merge(getEntity(),true);

    }

    @Override
    public void setEntity(TermVocabulary entity) {
        super.setEntity(entity);
        vocabularyPage.getDetailElement().setEntity(entity);
    }

    @Override
    protected String getEntityName() {
        return "Vocabulary";
    }
}
