/**
 * Copyright (C) 2014 EDIT
 * European Distributed Institute of Taxonomy
 * http://www.e-taxonomy.eu
 *
 * The contents of this file are subject to the Mozilla Public License Version 1.1
 * See LICENSE.TXT at the top of this package for the full license terms.
 */
package eu.etaxonomy.taxeditor.newWizard;

import eu.etaxonomy.cdm.api.conversation.ConversationHolder;
import eu.etaxonomy.cdm.model.term.TermVocabulary;
import eu.etaxonomy.taxeditor.ui.element.AbstractCdmEntityWizardPage;
import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
import eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailElement;
import eu.etaxonomy.taxeditor.ui.section.vocabulary.TermVocabularyDetailElement;

/**
 * @author pplitzner
 * @date 11.03.2014
 *
 */
public class VocabularyWizardPage extends AbstractCdmEntityWizardPage<TermVocabulary> {

    public VocabularyWizardPage(CdmFormFactory formFactory,
            ConversationHolder conversation, TermVocabulary entity) {
        super(formFactory, conversation, entity);
        setTitle("General Vocabulary Data");
    }

    @Override
    protected void checkComplete() {
        setPageComplete(getEntity().getLabel()!=null);
    }

    @Override
    public AbstractCdmDetailElement<TermVocabulary> createElement(ICdmFormElement rootElement) {
        TermVocabularyDetailElement detailElement = formFactory.createTermVocabularyDetailElement(rootElement);
        getEntity().setLabel(null);
        detailElement.setEntity(getEntity());
        checkComplete();
        return detailElement;
    }

}
