/**
* Copyright (C) 2015 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.operation;

import java.util.UUID;

/**
 * Generates feeback for waiting remoting progress monitors.
 * The default implementation of this interface is {@link FeedbackGenerator}
 *
 * @author cmathew
 * @date 28 Oct 2015
 *
 */
public interface IFeedbackGenerator {

    /**
     * Generates and sets feedback for a waiting remoting progress
     * monitor corresponding to the given uuid.
     *
     * @param uuid of target waiting remoting progress monitor
     */
    public void setFeedbackForMonitor(UUID uuid);

}
