/**
* Copyright (C) 2018 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.preference;

import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;

import eu.etaxonomy.cdm.model.metadata.PreferencePredicate;
import eu.etaxonomy.taxeditor.preference.menu.CdmPreferencePage;

/**
 * @author k.luther
 * @since 23.03.2018
 *
 */
public class AbcdImportProvider extends CdmPreferencePage implements IE4PreferencePage{

    protected ListComponent biocaseProviderList;
    protected Button allowOverride;

    @Override
    protected Control createContents(Composite parent) {
        final Composite composite = new Composite(parent, SWT.NULL);

        GridLayout gridLayout = new GridLayout();
        composite.setLayout(gridLayout);

        gridLayout.numColumns = 3;
        //gridLayout.horizontalSpacing= 5;
        //gridLayout.makeColumnsEqualWidth = true;

        composite.setLayout(gridLayout);
        biocaseProviderList = new ListComponent(composite, SWT.SCROLL_LINE,false, this);

        setApply(true);
        return composite;
    }

    @Override
    public boolean performOk() {
        String providerList = null;
        if (biocaseProviderList != null){
            providerList = biocaseProviderList.createAllProviderString();
            PreferencesUtil.setStringValue(PreferencePredicate.BioCaseProvider.getKey(), providerList);
            PreferencesUtil.setBooleanValue(PreferencesUtil.createOverridePreferenceString(PreferencePredicate.BioCaseProvider.getKey()), true);

        }

        return true;
    }

}
