/**
* Copyright (C) 2019 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.preference;

import java.util.ArrayList;
import java.util.List;
import java.util.UUID;

import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Table;

import eu.etaxonomy.cdm.api.service.IVocabularyService;
import eu.etaxonomy.cdm.model.metadata.CdmPreference;
import eu.etaxonomy.cdm.model.term.TermType;
import eu.etaxonomy.cdm.persistence.dto.TermVocabularyDto;
import eu.etaxonomy.taxeditor.preference.menu.CdmPreferencePage;
import eu.etaxonomy.taxeditor.store.CdmStore;

/**
 * @author k.luther
 * @since 30.08.2019
 */
public abstract class AbstractVocabularySelectionPreference extends CdmPreferencePage {
    protected Table table;

    protected CdmPreference pref;
    protected TermType type;
    protected List<CdmPreference> prefsToDelete = new ArrayList<>();
    protected List<TermVocabularyDto> vocabularies;
    protected boolean override;

    @Override
    protected Control createContents(Composite parent) {
        // TODO Auto-generated method stub
        return null;
    }

    /**
    *
    */
   protected void refresh() {
       //getValues();
       if (table != null){
           table.removeAll();
           if (pref != null){
               createTableRow(pref);
           }
           table.redraw();
           table.pack();

       }

   }

   public abstract void createTableRow(CdmPreference pref) ;
  // public abstract String getUUIDFromSubject(CdmPreference pref);

   protected void fillVocabularies(CdmPreference vocPref){
       List<UUID> uuids = null;
       if (isAdminPreference){
           uuids = PreferencesUtil.createUuidList(vocPref.getValue());
       }else{
           uuids = PreferencesUtil.createUUIDListFromStringPref(vocPref.getPredicate(), false);
       }
       if (uuids == null || uuids.isEmpty()){
           vocabularies = new ArrayList();
           vocabularies = CdmStore.getService(IVocabularyService.class).findVocabularyDtoByTermType(type);
       }else{
           vocabularies =  CdmStore.getService(IVocabularyService.class).findVocabularyDtoByVocabularyUuids(uuids);
       }
   }

}
