/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.preference;

import org.eclipse.jface.preference.BooleanFieldEditor;

import eu.etaxonomy.taxeditor.l10n.Messages;
import eu.etaxonomy.taxeditor.preference.menu.FieldEditorPreferencePageE4;

/**
 * <p>DescriptionPreferences class.</p>
 *
 * @author p.ciardelli
 * @created 20.05.2008
 * @version 1.0
 */
public class DescriptionPreferences extends FieldEditorPreferencePageE4 {

	/** Constant <code>PLUGIN_ID="eu.etaxonomy.taxeditor.preferences.desc"{trunked}</code> */
	public static final String PLUGIN_ID = "eu.etaxonomy.taxeditor.preferences.description"; //$NON-NLS-1$

	@Override
	protected void createFieldEditors() {

	    addField(new BooleanFieldEditor(PreferencesUtil.createPreferenceString(IPreferenceKeys.SHOW_VOCABULARY_ID_FOR_TERM_LABELS),
	            Messages.DescriptionPreferences_1,
                getFieldEditorParent()));
	}
}
