/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.preference;

import eu.etaxonomy.cdm.model.occurrence.FieldUnit;
import eu.etaxonomy.taxeditor.store.CdmStore;

/**
 * <p>IPreferenceKeys interface.</p>
 *
 * @author n.hoffmann
 * @created Jul 12, 2010
 * @version 1.0
 */
public interface IPreferenceKeys {
	/**
	 *
	 */
	//public static final String PREFERRED_NOMENCLATURAL_CODE_KEY = "eu.etaxonomy.taxeditor.nomenclaturalCode";

	/**
	 * TaxonSearch Configurator
	 */
	public static final String TAXON_SERVICE_CONFIGURATOR_TAXA = "eu.etaxonomy.taxeditor.taxonServiceConfigurator.doTaxa";

	public static final String TAXON_SERVICE_CONFIGURATOR_SYNONYMS = "eu.etaxonomy.taxeditor.taxonServiceConfigurator.doSynonyms";

	public static final String TAXON_SERVICE_CONFIGURATOR_NAMES = "eu.etaxonomy.taxeditor.taxonServiceConfigurator.doNamesWithoutTaxa";

	public static final String TAXON_SERVICE_CONFIGURATOR_COMMON_NAMES = "eu.etaxonomy.taxeditor.taxonServiceConfigurator.doTaxaByCommonNames";

	public static final String TAXON_SERVICE_CONFIGURATOR_MATCH_MODE = "eu.etaxonomy.taxeditor.taxonServiceConfigurator.doSearchByMatchMode";

	public static final String TAXON_SERVICE_CONFIGURATOR_UNPUBLISHED =  "eu.etaxonomy.taxeditor.taxonServiceConfigurator.doUnpublishedTaxa";

	public static final String TAXON_SERVICE_CONFIGURATOR_WITH_AUTHORS =  "eu.etaxonomy.taxeditor.taxonServiceConfigurator.doWithAuthors";
	/**
	 * Whether to show UUID and database id in the supplemental data view.
	 */
	public static final String SHOW_DEBUG_INFORMATION = "eu.etaxonomy.taxeditor.showDebugInformation";

	/**
	 * Whether to show database id in the entity selection dialogs.
	 */
	//public static final String SHOW_ID_IN_ENTITY_SELECTION_DIAOLOG = "eu.etaxonomy.taxeditor.showIdInEntitySelectionDiaolog";

	/**
	 * Whether to show vocabulary of the term when displaying it's label.
	 */
	public static final String SHOW_VOCABULARY_ID_FOR_TERM_LABELS = "eu.etaxonomy.taxeditor.showVocabularyIdForTermLabels";
	/**
     * Whether to show vocabulary of the term when displaying it's label.
     */
    public static final String SHOW_VOCABULARY_ID_FOR_TERM_LABELS_IN_TREE_EDITOR = "eu.etaxonomy.taxeditor.showVocabularyIdForTermLabelsInTreeEditor";

	/**
	 *
	 */
	public static final String HIDE_BULKEDITOR_INFO = "eu.etaxonomy.taxeditor.bulkeditorInfo.hide";

	/**
	 *
	 */
	public static final String EDIT_MARKER_TYPE_PREFIX = "editMarkerType";

	/**
	 *
	 */
	public static final String MATCH_STRATEGY_PREFIX = "matchStrategy.";



	/**
	 * Whether the editor should connect to a database immediately after starting.
	 * When editor launches for the first time, it will use the default h2 database.
	 * Subsequent launches will always try to connect to the database it was connected to during
	 * the previous session.
	 */
	public static final String SHOULD_CONNECT_AT_STARTUP = "eu.etaxonomy.taxeditor.shouldConnectAtStartup";

	/** Constant <code>SHOULD_EXPAND_SECTION_WHEN_DATA_AVAILABLE="eu.etaxonomy.taxeditor.shouldExpandSect"{trunked}</code> */
	public static final String SHOULD_EXPAND_SECTION_WHEN_DATA_AVAILABLE = "eu.etaxonomy.taxeditor.shouldExpandSectionWhenDataAvailable";

	/** Constant <code>FEATURE_TREE_DEFAULT_TEXT="eu.etaxonomy.taxeditor.featureTree.defa"{trunked}</code> */
	public static final String FEATURE_TREE_DEFAULT_TEXT = "eu.etaxonomy.taxeditor.featureTree.default.textualData";

	/** Constant <code>FEATURE_TREE_DEFAULT_STRUCTURE="eu.etaxonomy.taxeditor.featureTree.defa"{trunked}</code> */
	public static final String FEATURE_TREE_DEFAULT_STRUCTURE = "eu.etaxonomy.taxeditor.featureTree.default.structuralData";



	/** Constant <code>RESTORE_NAVIGATOR_STATE="eu.etaxonomy.taxeditor.taxonnavigator.restoreState"{trunked}</code> */
	public static final String RESTORE_NAVIGATOR_STATE = "eu.etaxonomy.taxeditor.taxonnavigator.restoreState";


	/**
	 * The language to be used for all things multilanguage
	 */
	public static final String GLOBAL_LANGUAGE_UUID = "eu.etaxonomy.taxeditor.globalLanguage";

	public static final String SHOW_EXPERIMENTAL_FEATURES = "eu.etaxonomy.taxeditor.showExperimentalFeatures";

	/**
	 * Whether the occurrence bulk editor should show {@link FieldUnit} objects
	 */
	public static final String BULK_EDITOR_OCCURRENCE_SHOW_FIELD_UNITS = "eu.etaxonomy.taxeditor.bulkeditor.occurrence.showFieldUnits";
	public static final String SEARCH_OPEN_RESULTS_IN_SEPARATE_WINDOWS = "eu.etaxonomy.taxeditor.navigation.search.openResultInSeparateWindows";
	public static final String DISABLE_SERVICES_API_TIMESTAMP_CHECK = "eu.etaxonomy.taxeditor.cdmlib.remoting.disableServicesApiTimestampCheck";
	public static final String ADD_TYPES_TO_ALL_NAMES = "eu.etaxonomy.taxeditor.store.addTypeToAllNames";




    public static final String PROMPT_FOR_OPEN_SPECIMEN_IN_EDITOR = "eu.etaxonomy.taxeditor.specimen.promptForOpenSpecimenInEditor";

    public static final String DEFAULT_LANGUAGE_EDITOR = "eu.etaxonomy.taxeditor.default.language";

    public static final String IS_SHOW_UP_WIDGET_IS_DISPOSED = "eu.etaxonomy.taxeditor.isShowUpWidgetIsDisposed";

    /**
     * Key for the saved P2 repositories
     */
    public static final String P2_REPOSITORY_LIST = "eu.etaxonomy.taxeditor.p2.repositories";

    public static final String ALLOW_OVERRIDE_RL = "eu.etaxonomy.taxeditor.isRL.allow_override";


    public static final String SHOW_ADVANCED_MEDIA_SECTION = "eu.etaxonomy.taxeditor.media.showAdvancedMedia" + CdmStore.getActiveCdmSource().getName();
    public static final String SHOW_MEDIA_PREVIEW = "eu.etaxonomy.taxeditor.media.showMediaPreview"+ CdmStore.getActiveCdmSource().getName();

    public static final String LAST_SELECTED_REFERENCES = "eu.etaxonomy.taxeditor.references.selection.lastSelected";
    public static final String LAST_USED_ABCD_CONFIG = "eu.etaxonomy.taxeditor.io.abcd.lastUsedConfig";
    public static final String LAST_USED_BIOCASE_PROVIDER = "eu.etaxonomy.taxeditor.io.abcd.lastUsedBiocaseProvider";
}
