/**
* Copyright (C) 2019 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.preference;

import eu.etaxonomy.cdm.model.metadata.IKeyLabel;

/**
 * @author k.luther
 * @since 05.06.2019
 *
 */
public enum LocalOrDefaultEnum implements IKeyLabel{
    Local("Local", "Use local settings"),
    Database("NotAllowOverride", "Do not allow override"),
    Default("Default", "Use default settings"),
    AllowOverride("AllowOverride", "Allow override");


    String label;
    String key;

    private LocalOrDefaultEnum(String key, String label){
        this.label = label;
        this.key = key;
    }

    @Override
    public String getLabel(){
        return label;
    }

    @Override
    public String getKey(){
        return key;
    }
}
