/**
* Copyright (C) 2014 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.preference;

import org.eclipse.jface.preference.BooleanFieldEditor;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Label;

import eu.etaxonomy.taxeditor.l10n.Messages;
import eu.etaxonomy.taxeditor.preference.menu.CdmPreferencePage;

/**
 * @author pplitzner
 * @date 13.02.2014
 *
 */
public class MediaPreferences extends CdmPreferencePage {

    BooleanFieldEditor advanced;
    BooleanFieldEditor preview;

    @Override
    protected Control createContents(Composite parent) {
       Composite top = new Composite(parent, SWT.LEFT);


       top.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));
       Label mediaDetailsView = new Label(top, SWT.NULL);
       mediaDetailsView.setText("Details View");
       advanced = new BooleanFieldEditor(PreferencesUtil.createPreferenceString(IPreferenceKeys.SHOW_ADVANCED_MEDIA_SECTION),
                Messages.MediaPreferences_advanced,
                top);
       advanced.setPreferenceStore(getPreferenceStore());
       advanced.load();


       Label mediaView = new Label(top, SWT.NULL);
       mediaView.setText("Media View");
       preview = new BooleanFieldEditor(PreferencesUtil.createPreferenceString(IPreferenceKeys.SHOW_MEDIA_PREVIEW),
                Messages.MediaPreferences_preview,
                top);
       preview.setPreferenceStore(getPreferenceStore());
       preview.load();

       return top;

    }

    @Override
    public void createControl(Composite parent){
        super.createControl(parent);
        if (getApplyButton() != null){
            this.getApplyButton().setEnabled(true);
        }
    }

    @Override
    public boolean performOk() {
       if (advanced != null){
           advanced.store();
           preview.store();
       }
       return super.performOk();

    }
    @Override
    protected void performDefaults() {
        advanced.loadDefault();
        preview.loadDefault();
        super.performDefaults();
    }




}
