/**
 * Copyright (C) 2007 EDIT
 * European Distributed Institute of Taxonomy
 * http://www.e-taxonomy.eu
 *
 * The contents of this file are subject to the Mozilla Public License Version 1.1
 * See LICENSE.TXT at the top of this package for the full license terms.
 */

package eu.etaxonomy.taxeditor.preference;

import org.eclipse.jface.preference.IntegerFieldEditor;
import org.eclipse.jface.preference.StringFieldEditor;

import eu.etaxonomy.cdm.model.metadata.PreferencePredicate;
import eu.etaxonomy.taxeditor.preference.menu.FieldEditorPreferencePageE4;

/**
 * @author n.hoffmann
 * @created Feb 4, 2011
 * @version 1.0
 */
public class MobotOpenUrlPreferences extends FieldEditorPreferencePageE4 {


    @Override
    protected void createFieldEditors() {
        addField(new StringFieldEditor(
                PreferencesUtil.createPreferenceString(PreferencePredicate.MobotOpenUrlServiceAccessPoint.getKey()),
                "Mobot Open Url Service Access Point:", getFieldEditorParent()));
        addField(new IntegerFieldEditor(
                PreferencesUtil.createPreferenceString(PreferencePredicate.MobotOpenUrlServiceMaxWidth.getKey()),
                "Image Maximum Width:",
                getFieldEditorParent()));
        addField(new IntegerFieldEditor(
                PreferencesUtil.createPreferenceString(PreferencePredicate.MobotOpenUrlServiceMaxHeight.getKey()),
                "Image Maximum Height:",
                getFieldEditorParent()));

    }

}
