/**
* Copyright (C) 2018 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.preference;

import eu.etaxonomy.cdm.model.metadata.IKeyLabel;
import eu.etaxonomy.taxeditor.l10n.Messages;

/**
 * @author k.luther
 * @since 19.11.2018
 *
 */
public enum NavigatorOrderEnum implements IKeyLabel{
    AlphabeticalOrder("AlphabeticalOrder", Messages.NavigatorOrderEnum_1), //$NON-NLS-1$
    NaturalOrder("NaturalOrder", Messages.NavigatorOrderEnum_3), //$NON-NLS-1$
    RankAndNameOrder("RankAndNameOrder", Messages.NavigatorOrderEnum_5); //$NON-NLS-1$


    String label;
    String key;

    private NavigatorOrderEnum(String key, String label){
        this.label = label;
        this.key = key;
    }

    @Override
    public String getLabel(){
        return label;
    }

    @Override
    public String getKey(){
        return key;
    }
}
