/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.preference;

import org.eclipse.core.expressions.PropertyTester;

import eu.etaxonomy.cdm.model.metadata.PreferencePredicate;

/**
 * @author n.hoffmann
 * @created Jan 26, 2011
 * @version 1.0
 */
public class PreferencePropertyTester extends PropertyTester {


	private static final String SHOW_EXPERIMENTAL_FEATURES = "isShowExperimentalFeatures";

    private static final String SHOW_CHECKLIST_EDITOR = "isChecklistEditorEnabled";

    private static final String SHOW_IO_MENU = "isShowIOMenuEnabled";

    private static final String SHOW_SPECIMEN_MENU = "isShowSpecimenMenuEnabled";

    private static final String SHOW_SPECIMEN_LIST_MENU = "isShowSpecimenListMenuEnabled";

	@Override
	public boolean test(Object receiver, String property, Object[] args,
			Object expectedValue) {
		if(SHOW_EXPERIMENTAL_FEATURES.equals(property)){
			return isShowExperimentalFeatures();
		}
	    if(SHOW_CHECKLIST_EDITOR.equals(property)){
	        return isChecklistEditorEnabled();
	    }
	    if(SHOW_IO_MENU.equals(property)){
	        boolean test = isShowIOMenuEnabled();
            return isShowIOMenuEnabled();
        }
	    if(SHOW_SPECIMEN_MENU.equals(property)){
            return isShowSpecimenMenuEnabled();
        }
	    if(SHOW_SPECIMEN_LIST_MENU.equals(property)){
            return isShowSpecimenListMenuEnabled();
        }
		return false;
	}

	/**
	 * @return
	 */
	private boolean isShowExperimentalFeatures() {
		return PreferencesUtil.getBooleanValue(IPreferenceKeys.SHOW_EXPERIMENTAL_FEATURES);
	}

	private boolean isChecklistEditorEnabled() {
        return PreferencesUtil.getBooleanValue(PreferencePredicate.DistributionEditorActivated.getKey());
    }
	private boolean isShowIOMenuEnabled() {
        return PreferencesUtil.getBooleanValue(PreferencePredicate.ShowImportExportMenu.getKey());
    }

	private boolean isShowSpecimenMenuEnabled() {
        return PreferencesUtil.getBooleanValue(PreferencePredicate.ShowSpecimen.getKey());
    }

	private boolean isShowSpecimenListMenuEnabled() {
        return PreferencesUtil.getBooleanValue(PreferencePredicate.ShowSpecimen.getKey()) && PreferencesUtil.getBooleanValue(PreferencePredicate.ShowSpecimenListEditor.getKey());
    }

}
