/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.preference.menu;

import eu.etaxonomy.cdm.model.metadata.PreferencePredicate;
import eu.etaxonomy.cdm.model.term.TermType;
import eu.etaxonomy.taxeditor.l10n.Messages;
import eu.etaxonomy.taxeditor.preference.GeneralTermPreferencePage;

/**
 * <p>LanguageMenuPreferences class.</p>
 *
 * @author p.ciardelli
 * @created 24.08.2009
 * @version 1.0
 */
public class CommonNameLanguagePreferences extends GeneralTermPreferencePage {

	/** Constant <code>ID="eu.etaxonomy.taxeditor.preferences.lang"{trunked}</code> */
	public final static String ID = "eu.etaxonomy.taxeditor.preferences.languages"; //$NON-NLS-1$

	/**
	 * <p>Constructor for LanguageMenuPreferences.</p>
	 */
	public CommonNameLanguagePreferences() {
	    super(Messages.CommonNameLanguages_Title);

        isAdminPreference = false;

        setPredicate(PreferencePredicate.CommonNameLanguages);
        setDescription(Messages.CommonNameLanguagePreferencePage_description);
        type = TermType.Language;

	}


}
