/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.preference.menu;

import eu.etaxonomy.cdm.model.term.TermType;
import eu.etaxonomy.cdm.model.description.PresenceAbsenceTerm;
import eu.etaxonomy.taxeditor.l10n.Messages;

/**
 * <p>PresenceAbsenceMenuPreferences class.</p>
 *
 * @author n.hoffmann
 * @created 25.06.2009
 * @version 1.0
 */
public class PresenceAbsenceMenuPreferences extends AbstractMenuPreferences<PresenceAbsenceTerm> {

	public PresenceAbsenceMenuPreferences() {
		super("Distribution Status Preferences", //$NON-NLS-1$
				Messages.PresenceAbsenceMenuPreferences_choose,
				false);
	}

	/** {@inheritDoc} */
	@Override
	protected TermType getTermType() {
		return TermType.PresenceAbsenceTerm;
	}

}
