/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.preference.menu;

import eu.etaxonomy.cdm.model.term.DefinedTerm;
import eu.etaxonomy.cdm.model.term.TermType;
import eu.etaxonomy.taxeditor.l10n.Messages;

/**
 * <p>PreservationMethodMenuPreferences class.</p>
 *
 * @author n.hoffmann
 * @created Jun 25, 2010
 * @version 1.0
 */
public class PreservationMethodMenuPreferences extends AbstractMenuPreferences<DefinedTerm>  {
//FIXME:3.3MC---- see Ticket #3732
//extends AbstractMenuPreferences<PreservationMethod> {
  //FIXME:3.3MC----

	/**
	 * <p>Constructor for PreservationMethodMenuPreferences.</p>
	 */
	public PreservationMethodMenuPreferences() {
		super("Preservation Method Preferences", //$NON-NLS-1$
				Messages.PreservationMethodMenuPreferences_select,
				false);
	}

	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.preference.menu.AbstractMenuPreferences#getTermClass()
	 */
	/** {@inheritDoc} */
	@Override
	protected TermType getTermType() {
		return TermType.MaterialOrMethod;
	}
}
