/**
* Copyright (C) 2018 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.preference.wizard;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;

import eu.etaxonomy.cdm.model.metadata.CdmPreference;
import eu.etaxonomy.cdm.model.term.TermType;
import eu.etaxonomy.cdm.persistence.dto.AbstractTermDto;
import eu.etaxonomy.taxeditor.preference.PreferencesUtil;


/**
 * @author k.luther
 * @since 22.11.2018
 *
 */
public abstract class AbstractAdminTermSelectionWizardPage<T extends AbstractTermDto> extends AbstractTermSelectionWizardPage{
    //private boolean localPrefExist = true;

    /**
     * @param pageName
     * @param type
     */
    protected AbstractAdminTermSelectionWizardPage(String pageName, TermType type, CdmPreference pref) {
        super(pageName, type);
        this.pref = pref;
        if (localPref){
            this.override = PreferencesUtil.getOverrideForPreference(pref.getPredicate());
        }else{
            this.override = pref != null? this.pref.isAllowOverride(): true;
        }

    }

//    CdmPreference pref;
 //   boolean override;

    /**
     * {@inheritDoc}
     * @return
     */

    @Override
    protected Button createAllowOverrideButton(Composite parent) {
       Button activateCheckButton = new Button(parent, SWT.CHECK);
       if (localPref){
           activateCheckButton.setText("Override");

       }else{
           activateCheckButton.setText("Allow Override");

       }

       activateCheckButton.setSelection(override);

        activateCheckButton.addSelectionListener(new SelectionAdapter(){
                @Override
                public void widgetSelected(SelectionEvent e) {
                    pref.setAllowOverride(activateCheckButton.getSelection());
                    override = activateCheckButton.getSelection();

                }
            });
        return activateCheckButton;
    }

//    public boolean isLocalPrefExist() {
//        return localPrefExist;
//    }
//
//    public void setLocalPrefExist(boolean localPrefExist) {
//        this.localPrefExist = localPrefExist;
//    }

    @Override
    public CdmPreference getPreference(){
        return pref;
    }

    public void setPreference(CdmPreference pref){
        this.pref = pref;
    }

}
