/**
* Copyright (C) 2018 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.preference.wizard;

import java.util.List;

import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;

import eu.etaxonomy.cdm.model.metadata.CdmPreference;
import eu.etaxonomy.cdm.model.metadata.PreferencePredicate;
import eu.etaxonomy.cdm.model.term.TermType;
import eu.etaxonomy.cdm.persistence.dto.TermVocabularyDto;
import eu.etaxonomy.taxeditor.l10n.Messages;
import eu.etaxonomy.taxeditor.preference.PreferencesUtil;



/**
 * @author k.luther
 * @since 05.10.2018
 *
 */
public class AvailableDistributionStatusPage extends TermSelectionWizardPage {

    Button overrideButton;

    public AvailableDistributionStatusPage(String pageName, CdmPreference pref, boolean localPref) {
        super(pageName, TermType.PresenceAbsenceTerm);
        this.pref = pref;
        this.localPref = localPref;
    }

    @Override
    public void createControl(Composite parent) {
        setTitle(Messages.AvailableDistributionStatusPage_PAGE_TITLE);
        setDescription(Messages.AvailableDistributionStatusPage_PAGE_DESCRIPTION);
        if (localPref){
            override = PreferencesUtil.getOverrideForPreference(PreferencePredicate.AvailableDistributionStatus.getKey());
        }
        overrideButton = createAllowOverrideButton(parent);


        super.createControl(parent);
        overrideButton.setSelection(override);
    }

    @Override
    protected String getCheckedValuesFromPreferences() {
       String checkedValues = null;
        if (localPref){
           checkedValues = PreferencesUtil.getStringValue(PreferencePredicate.AvailableDistributionStatus.getKey(), true);
        }else if(pref != null){
            checkedValues = pref.getValue();
        }
        return checkedValues;
    }

    @Override
    protected List<TermVocabularyDto> getVocabulariesFromPreference() {
        // TODO Auto-generated method stub
        return null;
    }






}
