/**
* Copyright (C) 2018 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.preference.wizard;

import java.util.Set;

import eu.etaxonomy.cdm.model.term.DefinedTermBase;

/**
 * @author k.luther
 * @since 04.10.2018
 *
 */
public class NamedAreaWrapper {

    boolean isBaseElement;
    DefinedTermBase namedArea;
    Set<NamedAreaWrapper> children;
    Object parent;

    public NamedAreaWrapper(DefinedTermBase namedArea, boolean isBaseElement, Object parent){
        this.isBaseElement = isBaseElement;
        this.namedArea = namedArea;
        this.parent = parent;

    }

    /**
     * @return
     */
    public DefinedTermBase getNamedArea() {
        return namedArea;
    }

    public Set<NamedAreaWrapper> getChildren(){
        return children;
    }
    @Override
    public boolean equals(Object wrapper){
        if (!(wrapper instanceof NamedAreaWrapper)){
            return false;
        }
        return (this.namedArea == ((NamedAreaWrapper)wrapper).namedArea && this.isBaseElement == ((NamedAreaWrapper)wrapper).isBaseElement);
    }

}
