/**
* Copyright (C) 2019 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.preference.wizard;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import java.util.UUID;

import org.apache.commons.lang3.StringUtils;

import eu.etaxonomy.cdm.api.service.ITermService;
import eu.etaxonomy.cdm.model.term.TermType;
import eu.etaxonomy.cdm.persistence.dto.TermDto;
import eu.etaxonomy.taxeditor.store.CdmStore;

/**
 * @author k.luther
 * @since 26.09.2019
 */
public abstract class TermSelectionWizardPage extends AbstractTermSelectionWizardPage<TermDto> {

    /**
     * @param pageName
     * @param type
     */
    protected TermSelectionWizardPage(String pageName, TermType type) {
        super(pageName, type);

    }

    @Override
    protected List<TermDto> getTermsFromStringValues(List<String> listValue) {
        Collection<TermDto> termlist = null ;
        ITermService termService = CdmStore.getService(ITermService.class);
        List<UUID> uuidList = new ArrayList();
        for (String s : listValue) {
            if (!StringUtils.isBlank(s)){
                UUID uuid = UUID.fromString(s);
                uuidList.add(uuid);
            }
        }
        if (!uuidList.isEmpty()){
            termlist = termService.findByUUIDsAsDto(uuidList);
        }

        if (listValue == null || listValue.isEmpty() ){
            termlist = termService.findByTitleAsDtoWithVocDto("", type);
        }
        return new ArrayList(termlist);
    }
}
