/**
* Copyright (C) 2015 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.store;

import org.eclipse.swt.widgets.Display;

import eu.etaxonomy.cdm.api.application.CdmChangeEvent;
import eu.etaxonomy.cdm.api.application.CdmDataChangeService;
import eu.etaxonomy.cdm.api.application.ICdmChangeListener;

/**
 * @author cmathew
 * @date 18 Jun 2015
 *
 */
public class CdmUIDataChangeService extends CdmDataChangeService {

    /* (non-Javadoc)
     * @see eu.etaxonomy.taxeditor.store.ICdmDataChangeService#fireChangeEvent(eu.etaxonomy.cdm.api.application.CdmChangeEvent, boolean)
     */
    @Override
    public void fireChangeEvent(final CdmChangeEvent event, boolean async) {

        for(final ICdmChangeListener listener : listeners) {
            // Update the user interface asynchronously
            if(async) {
                Display.getDefault().asyncExec(new Runnable() {
                    @Override
                    public void run() {
                        listener.onChange(event);
                    }
                });
            } else {
                // Update the user interface synchronously
                Display.getDefault().syncExec(new Runnable() {
                    @Override
                    public void run() {
                        listener.onChange(event);
                    }
                });
            }
        }
    }

}
