/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.termtree;

import java.util.List;

import org.eclipse.jface.wizard.Wizard;

import eu.etaxonomy.cdm.persistence.dto.AbstractTermDto;
import eu.etaxonomy.cdm.persistence.dto.TermDto;

/**
 *
 * @author pplitzner
 * @since Feb 14, 2019
 *
 */
public class TermChooseWizard extends Wizard {

	private TermChooseWizardPage page;

	private List<AbstractTermDto> selectedTerms;

    private TermDto term;

	public TermChooseWizard(TermDto term){
	    this.term = term;


	}

    public List<AbstractTermDto> getSelectedTerms() {
        return selectedTerms;
    }

	@Override
	public void addPages() {
		page = new TermChooseWizardPage(term);
		page.setPageComplete(false);
		addPage(page);
	}

	@Override
	public boolean performFinish() {
		selectedTerms = page.getSelectedTerms();

		return selectedTerms.size() > 0;
	}

}
