/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.termtree;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.jface.wizard.WizardPage;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Composite;

import eu.etaxonomy.cdm.persistence.dto.AbstractTermDto;
import eu.etaxonomy.cdm.persistence.dto.TermDto;
import eu.etaxonomy.taxeditor.view.search.facet.SearchComposite;
import eu.etaxonomy.taxeditor.view.search.facet.term.TermSearchController;

/**
 * @author pplitzner
 * @since Feb 14, 2019
 */
public class TermChooseWizardPage extends WizardPage {

    private TermSearchController controller;
    private TermDto term;

	protected TermChooseWizardPage(TermDto term) {
		super("Term Choose Wizard");
		setTitle("Choose Parent");
		setDescription("Please search and select the parent term or vocabulary (if you want to move the term as root).");
		this.term = term;
	}

	@Override
	public void createControl(Composite parent) {
        SearchComposite searchComposite = new SearchComposite(parent, SWT.NONE);
        controller = new TermSearchController(searchComposite, term, this);
		setControl(searchComposite);
	}

	public List<AbstractTermDto> getSelectedTerms() {
	    List<AbstractTermDto> termDtos = new ArrayList<>();
	    controller.getSelectedSearchResults().forEach(result->termDtos.add(result.getContent()));
	    return termDtos;
	}
}
