/**
 *
 */
package eu.etaxonomy.taxeditor.termtree;

import org.eclipse.core.expressions.PropertyTester;
import org.eclipse.jface.viewers.IStructuredSelection;

import eu.etaxonomy.cdm.model.term.TermTree;

/**
 * Property tester used by the feature tree menu.
 *
 * @author pplitzner
 * @since Jan 30, 2019
 *
 */
public class TermTreePropertyTester extends PropertyTester {

	private static final String FEATURE_TREE= "isTermTree"; //$NON-NLS-1$

	@Override
    public boolean test(Object receiver, String property, Object[] args,
			Object expectedValue) {

	    Object[] selectedElements = ((IStructuredSelection) receiver).toArray();

	    if(selectedElements.length == 0){
			// nothing selected so all tests should fail
			return false;
		}

		if(FEATURE_TREE.equals(property)){
		    return isTermTree(selectedElements);
		}
		else{
			return false;
		}
	}

	private boolean isTermTree(Object[] selectedElements) {
	    for (Object object : selectedElements){
	        if(!(object instanceof TermTree)){
	            return false;
	        }
	    }
	    return true;
	}

}
