/**
* Copyright (C) 2018 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.termtree.e4;

import java.util.UUID;

import org.eclipse.jface.viewers.TreeViewer;

import eu.etaxonomy.cdm.model.term.DefinedTermBase;
import eu.etaxonomy.cdm.model.term.TermNode;
import eu.etaxonomy.cdm.model.term.TermType;
import eu.etaxonomy.cdm.persistence.dto.TermNodeDto;
import eu.etaxonomy.cdm.persistence.dto.TermTreeDto;
import eu.etaxonomy.taxeditor.operation.AbstractPostOperation;
import eu.etaxonomy.taxeditor.operation.IPostOperationEnabled;
import eu.etaxonomy.taxeditor.session.ICdmEntitySessionEnabled;
import eu.etaxonomy.taxeditor.workbench.part.IE4SavablePart;

/**
 * @author pplitzner
 * @since Nov 22, 2018
 */
public interface ITermTreeEditor<T extends DefinedTermBase> 
		extends IPostOperationEnabled, IE4SavablePart, ICdmEntitySessionEnabled {

    public TermType getTermType();

    public TermNodeDto getNodeDtoForUuid(UUID nodeUuid);
    public TermTreeDto getTreeDtoForUuid(UUID treeUuid);
    public void setNodeDtoForUuid(TermNodeDto node);
    public void setTreeDtoForUuid(TermTreeDto tree);
    public boolean checkDuplicates(UUID termUuid, UUID treeUuid) ;


    public void addOperation(AbstractPostOperation<TermNode> operation);

    public void setDirty();

    public TreeViewer getViewer();
    public void refresh();
}