/**
* Copyright (C) 2017 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.termtree.e4.handler;

import javax.inject.Named;

import org.eclipse.e4.core.di.annotations.CanExecute;
import org.eclipse.e4.core.di.annotations.Optional;
import org.eclipse.e4.ui.model.application.ui.basic.MPart;
import org.eclipse.e4.ui.model.application.ui.menu.MHandledMenuItem;
import org.eclipse.e4.ui.services.IServiceConstants;
import org.eclipse.jface.viewers.IStructuredSelection;

import eu.etaxonomy.cdm.persistence.dto.TermNodeDto;
import eu.etaxonomy.taxeditor.termtree.e4.ITermTreeEditor;

/**
 * @author pplitzner
 * @since Jul 12, 2017
 */
public class AddChildTermHandler extends AbstractAddTermHandler{

    @CanExecute
    public boolean canExecute(
            @Optional@Named(IServiceConstants.ACTIVE_SELECTION)IStructuredSelection selection,
            @Named(IServiceConstants.ACTIVE_PART)MPart thisPart,
            MHandledMenuItem menuItem) {
        boolean canExecute = false;
        canExecute = thisPart.getObject() instanceof ITermTreeEditor
                && selection!=null
                && selection.size()==1
                && selection.getFirstElement() instanceof TermNodeDto
                && !((TermNodeDto)selection.getFirstElement()).getTree().isFlat();
        menuItem.setVisible(canExecute);
        return canExecute;
    }

    @Override
    protected TermNodeDto getParent(IStructuredSelection selection) {
        return (TermNodeDto)selection.getFirstElement();
    }
}
