/**
* Copyright (C) 2017 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.termtree.e4.handler;

import javax.inject.Named;

import org.eclipse.e4.core.di.annotations.CanExecute;
import org.eclipse.e4.core.di.annotations.Execute;
import org.eclipse.e4.core.di.annotations.Optional;
import org.eclipse.e4.ui.di.UISynchronize;
import org.eclipse.e4.ui.model.application.ui.basic.MPart;
import org.eclipse.e4.ui.model.application.ui.menu.MHandledMenuItem;
import org.eclipse.e4.ui.services.IServiceConstants;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.swt.widgets.Shell;

import eu.etaxonomy.cdm.persistence.dto.TermNodeDto;
import eu.etaxonomy.cdm.persistence.dto.TermTreeDto;
import eu.etaxonomy.taxeditor.termtree.e4.ITermTreeEditor;

/**
 * @author pplitzner
 * @since Jul 12, 2017
 *
 */
public class AddTermHandler extends AbstractAddTermHandler{

    @Execute
    public void execute(@Named(IServiceConstants.ACTIVE_SHELL) Shell shell,
            @Named(IServiceConstants.ACTIVE_SELECTION)IStructuredSelection selection,
            @Named(IServiceConstants.ACTIVE_PART)MPart thisPart, UISynchronize sync) {
        super.execute(shell, thisPart, selection, sync);
    }
//        IFeatureTreeEditor editor = ((IFeatureTreeEditor) thisPart.getObject());
//        if (StoreUtil.promptCheckIsDirty(editor)) {
//            return;
//        }
//        TermTreeDto tree = (TermTreeDto) selection.getFirstElement();
////
////        TermChooseWizard wizard = new TermChooseWizard(tree.getTermType());
////        WizardDialog dialog = new WizardDialog(shell, wizard);
////
////        if (dialog.open() == IStatus.OK) {
////            List<TermDto> selectedTerms = wizard.getSelectedTerms();
////            for (TermDto termDto: selectedTerms) {
////                AddFeatureOperation operation = new AddFeatureOperation(termDto.getUuid(), tree.getRoot(), editor, editor);
////                AbstractUtility.executeOperation(operation, sync);
////            }
////        }
//
//        AvailableFeaturesWizard wizard = new AvailableFeaturesWizard(tree.getTermType());
//        WizardDialog dialog = new WizardDialog(shell, wizard);
//
//        if (dialog.open() == IStatus.OK) {
//            Collection<DefinedTermBase> additionalTerms = wizard.getAdditionalFeatures();
//            for (DefinedTermBase term : additionalTerms) {
////                if (tree.getRoot().getUuid()== null){
////                    TermTree termTree = CdmStore.getService(ITermTreeService.class).load(tree.getUuid());
////                    tree = TermTreeDto.fromTree(termTree);
////                }
//                if (!tree.isAllowDuplicate()){
//                    boolean isDuplicate = editor.checkDuplicates(term.getUuid(), tree.getUuid());
//                    if (isDuplicate){
//                        MessagingUtils.informationDialog("No duplicates allowed", "This term tree does not allow duplicates.");
//                        return;
//                    }
//                }
//
//                AddFeatureOperation operation = new AddFeatureOperation(term.getUuid(), tree.getRoot(), editor, editor);
//                editor.addOperation(operation);
//                editor.setDirty();
//                if (editor instanceof ICharacterEditor){
//                    CharacterNodeDto newDto = new CharacterNodeDto(CharacterDto.fromCharacter((Character)term), tree.getRoot(), 0, tree, null, null, null);
//                }else{
//                    TermNodeDto newDto = new TermNodeDto(TermDto.fromTerm(term), tree.getRoot(), 0, tree, null, null, null);
//                }
//
////                ((AbstractTermTreeEditor)editor).getViewer().refresh();
//                if (editor instanceof ICharacterEditor){
//                    editor.refresh();
//                }else{
//                    Object[] expandedElements = ((AbstractTermTreeEditor)editor).getViewer().getExpandedElements();
//                    ((AbstractTermTreeEditor)editor).getViewer().setInput(((AbstractTermTreeEditor)editor).getTrees());
//                    ((AbstractTermTreeEditor)editor).getViewer().setExpandedElements(expandedElements);
//                }
//            }
//        }
//    }

    @CanExecute
    public boolean canExecute(
            @Optional@Named(IServiceConstants.ACTIVE_SELECTION)IStructuredSelection selection,
            @Named(IServiceConstants.ACTIVE_PART)MPart thisPart,
            MHandledMenuItem menuItem) {
        boolean canExecute = false;
        canExecute = thisPart.getObject() instanceof ITermTreeEditor
                && selection!=null
                && selection.size()==1
                && selection.getFirstElement() instanceof TermTreeDto;
        menuItem.setVisible(canExecute);
        return canExecute;
    }

    @Override
    protected TermNodeDto getParent(IStructuredSelection selection) {
        return ((TermTreeDto) selection.getFirstElement()).getRoot();
    }
}
