
package eu.etaxonomy.taxeditor.termtree.e4.handler;

import javax.inject.Named;

import org.eclipse.e4.core.di.annotations.CanExecute;
import org.eclipse.e4.core.di.annotations.Execute;
import org.eclipse.e4.core.di.annotations.Optional;
import org.eclipse.e4.ui.model.application.ui.basic.MPart;
import org.eclipse.e4.ui.model.application.ui.menu.MHandledMenuItem;
import org.eclipse.e4.ui.services.IServiceConstants;
import org.eclipse.jface.viewers.IStructuredSelection;

import eu.etaxonomy.cdm.persistence.dto.TermNodeDto;
import eu.etaxonomy.taxeditor.termtree.e4.TermTreeEditor;

public class CopyTermHandler {

    @Execute
    public void execute(@Named(IServiceConstants.ACTIVE_PART) MPart part,
            @Named(IServiceConstants.ACTIVE_SELECTION) IStructuredSelection selection){
        ((TermTreeEditor) part.getObject()).copy(selection);
    }

    @CanExecute
    public boolean canExecute(@Optional @Named(IServiceConstants.ACTIVE_SELECTION) IStructuredSelection selection,
            @Named(IServiceConstants.ACTIVE_PART) MPart part,
            MHandledMenuItem menuItem){
        boolean canExecute = false;
        canExecute =part.getObject() instanceof TermTreeEditor
                && selection!=null
                && selection.size()==1
                && selection.getFirstElement() instanceof TermNodeDto;
        menuItem.setVisible(canExecute);
        return canExecute;
    }

}