
package eu.etaxonomy.taxeditor.termtree.e4.handler;

import javax.inject.Named;

import org.eclipse.e4.core.di.annotations.CanExecute;
import org.eclipse.e4.core.di.annotations.Execute;
import org.eclipse.e4.core.di.annotations.Optional;
import org.eclipse.e4.ui.model.application.ui.basic.MPart;
import org.eclipse.e4.ui.model.application.ui.menu.MHandledMenuItem;
import org.eclipse.e4.ui.services.IServiceConstants;
import org.eclipse.jface.util.LocalSelectionTransfer;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;

import eu.etaxonomy.cdm.persistence.dto.TermDto;
import eu.etaxonomy.cdm.persistence.dto.TermNodeDto;
import eu.etaxonomy.cdm.persistence.dto.TermTreeDto;
import eu.etaxonomy.taxeditor.termtree.e4.TermTreeEditor;

public class PasteTermHandler {

    @Execute
    public void execute(@Named(IServiceConstants.ACTIVE_PART) MPart part,
            @Named(IServiceConstants.ACTIVE_SELECTION) IStructuredSelection selection){
        TermTreeEditor editor = (TermTreeEditor)part.getObject();
        editor.paste(selection);
    }

    @CanExecute
    public boolean canExecute(@Optional @Named(IServiceConstants.ACTIVE_SELECTION) IStructuredSelection selection,
            @Named(IServiceConstants.ACTIVE_PART) MPart part,
            MHandledMenuItem menuItem){
        boolean canExecute = false;
        ISelection transferSelection = LocalSelectionTransfer.getTransfer().getSelection();
        TermDto term = null;
        TermTreeDto moveToTree = null;
        if (((IStructuredSelection)transferSelection).getFirstElement() instanceof TermNodeDto){
            term = ((TermNodeDto)((IStructuredSelection)transferSelection).getFirstElement()).getTerm();
        }
        TermNodeDto selectedNode = null;
        if (selection.getFirstElement() instanceof TermNodeDto){
            selectedNode = (TermNodeDto)selection.getFirstElement();
            moveToTree = selectedNode.getTree();
        }else if (selection.getFirstElement() instanceof TermTreeDto){
            moveToTree = (TermTreeDto)selection.getFirstElement();
        }
        canExecute = part.getObject() instanceof TermTreeEditor
                && selection!=null
                && selection.size()==1
                && transferSelection instanceof IStructuredSelection
                && ((IStructuredSelection)transferSelection).size()==1
                && ((IStructuredSelection)transferSelection).getFirstElement() instanceof TermNodeDto
                && !moveToTree.getTerms().contains(term) || moveToTree.isAllowDuplicate()
                && !moveToTree.isFlat() || selectedNode == null;
        menuItem.setVisible(canExecute);
        return canExecute;
    }

}