// $Id$
/**
* Copyright (C) 2018 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.ui.combo;

import java.util.ArrayList;
import java.util.List;

import eu.etaxonomy.cdm.model.taxon.TaxonRelationshipType;
import eu.etaxonomy.taxeditor.ui.combo.term.TermComboElement;
import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;

/**
 * @author k.luther
 * @date 16.02.2018
 *
 */
public class MisappliedRelationshipComboElement extends TermComboElement<TaxonRelationshipType> {

    /**
     * @param formFactory
     * @param parentElement
     * @param termType
     * @param labelString
     * @param selection
     * @param addEmptyElement
     * @param style
     * @param useAbbrevLabel
     * @param comparator
     */
    public MisappliedRelationshipComboElement(CdmFormFactory formFactory, ICdmFormElement parentElement,
             String labelString, TaxonRelationshipType selection, boolean addEmptyElement, int style, boolean useAbbrevLabel) {
        super(formFactory, parentElement, TaxonRelationshipType.class, labelString, selection, addEmptyElement, style);
        List<TaxonRelationshipType> relTypes = new ArrayList<>();
        if (selection.isAnyMisappliedName()){
            relTypes.add(TaxonRelationshipType.MISAPPLIED_NAME_FOR());
            relTypes.add(TaxonRelationshipType.PRO_PARTE_MISAPPLIED_NAME_FOR());
            relTypes.add(TaxonRelationshipType.PARTIAL_MISAPPLIED_NAME_FOR());
        }else if (selection.isAnySynonym()){
            relTypes.add(TaxonRelationshipType.PRO_PARTE_SYNONYM_FOR());
            relTypes.add(TaxonRelationshipType.PARTIAL_SYNONYM_FOR());
        }
        addTerms(relTypes);
        populateTerms();
        setSelection(selection);
    }

}
