/**
* Copyright (C) 2017 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.ui.combo.taxon;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

import org.eclipse.jface.viewers.IStructuredContentProvider;

import eu.etaxonomy.cdm.api.service.ITaxonNodeService;
import eu.etaxonomy.cdm.model.taxon.TaxonNode;
import eu.etaxonomy.taxeditor.store.CdmStore;

/**
 * @author pplitzner
 * @since Nov 24, 2017
 *
 */
public class TaxonNodeComboContentProvider implements IStructuredContentProvider {

    @Override
    public Object[] getElements(Object inputElement) {
    	boolean includeUnpublished = true;
        
    	Collection<TaxonNode> nodes = (Collection<TaxonNode>)inputElement;
        List<TaxonNode> allNodes = new ArrayList<>();
        nodes.forEach(node->{
            allNodes.add(node);
            allNodes.addAll(CdmStore.getService(ITaxonNodeService.class).loadChildNodesOfTaxonNode(
            		node, null, true, includeUnpublished, null));
        });
        return allNodes.toArray();
    }

}
