/**
* Copyright (C) 2017 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.ui.combo.termvocabulary;

import org.eclipse.jface.viewers.LabelProvider;

import eu.etaxonomy.cdm.model.term.Representation;
import eu.etaxonomy.cdm.model.term.TermVocabulary;
import eu.etaxonomy.taxeditor.preference.PreferencesUtil;

/**
 *
 * @author pplitzner
 * @since Aug 17, 2018
 *
 */
public class TermVocabularyComboLabelProvider extends LabelProvider {

    @Override
    public String getText(Object element) {
        if(element instanceof TermVocabulary){
        	Representation rep = ((TermVocabulary) element).getPreferredRepresentation(PreferencesUtil.getGlobalLanguage());
        	return rep != null? rep.getLabel():((TermVocabulary) element).getTitleCache();
        }
        return super.getText(element);
    }

}
