// $Id$
/**
* Copyright (C) 2017 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.ui.dialog.configurator;

import org.eclipse.jface.wizard.Wizard;

import eu.etaxonomy.cdm.api.service.config.PublishForSubtreeConfigurator;
import eu.etaxonomy.taxeditor.l10n.Messages;

/**
 * @author k.luther
 * @date 11.10.2017
 *
 */
public class SetPublishForSubtreeWizard extends Wizard {

    private final PublishForSubtreeConfigurator configurator;
    private PublishSubTreeConfiguratorWizardPage page;


    /**
     * @param parentShell
     * @param dialogTitle
     * @param dialogTitleImage
     * @param dialogMessage
     * @param dialogImageType
     * @param dialogButtonLabels
     * @param defaultIndex
     * @param config
     */
    public SetPublishForSubtreeWizard(PublishForSubtreeConfigurator config) {
        super();
        this.configurator = config;
        setNeedsProgressMonitor(true);
        this.setWindowTitle(Messages.SetPublishConfiguration_Title);

    }



    /**
     * {@inheritDoc}
     */
    @Override
    public boolean performFinish() {
       page.updateContext();
       return true;

    }

    /* (non-Javadoc)
     * @see org.eclipse.jface.wizard.Wizard#addPages()
     */
    /** {@inheritDoc} */
    @Override
    public void addPages() {
        page = new PublishSubTreeConfiguratorWizardPage(configurator);
        addPage(page);

    }



}
