/**
* Copyright (C) 2017 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.ui.dialog.configurator;

import org.eclipse.jface.wizard.Wizard;

import eu.etaxonomy.cdm.api.service.config.SecundumForSubtreeConfigurator;
import eu.etaxonomy.cdm.model.reference.Reference;
import eu.etaxonomy.taxeditor.l10n.Messages;

/**
 * @author k.luther
 * @date 10.02.2017
 *
 */
public class SetSecundumForSubtreeConfigurationWizard extends Wizard {

    Reference newSecRef;
    private final SecundumForSubtreeConfigurator configurator;


    private SetSecundumConfiguratorWizardPage page;



    /**
     * @param parentShell
     * @param dialogTitle
     * @param dialogTitleImage
     * @param dialogMessage
     * @param dialogImageType
     * @param dialogButtonLabels
     * @param defaultIndex
     * @param config
     */
    public SetSecundumForSubtreeConfigurationWizard(SecundumForSubtreeConfigurator config) {
        super();
       // super(parentShell, dialogTitle, dialogTitleImage, dialogMessage, dialogImageType, dialogButtonLabels, defaultIndex);
        this.configurator = config;
        setNeedsProgressMonitor(true);
        this.setWindowTitle(Messages.SetSecundumConfiguration_Title);



    }









    /**
     * {@inheritDoc}
     */
    @Override
    public boolean performFinish() {
       if (!(configurator.isIncludeAcceptedTaxa() || configurator.isIncludeSynonyms())){
           return false;
       }else{
           return true;
       }
    }

    /* (non-Javadoc)
     * @see org.eclipse.jface.wizard.Wizard#addPages()
     */
    /** {@inheritDoc} */
    @Override
    public void addPages() {
        page = new SetSecundumConfiguratorWizardPage(configurator);
        addPage(page);
    }


}
