/**
* Copyright (C) 2019 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.ui.dialog.configurator.wizard;

import java.util.ArrayList;
import java.util.Collection;

import eu.etaxonomy.cdm.api.service.IVocabularyService;
import eu.etaxonomy.cdm.persistence.dto.TermDto;
import eu.etaxonomy.cdm.persistence.dto.TermVocabularyDto;
import eu.etaxonomy.taxeditor.editor.definedterm.TermDtoContentProvider;
import eu.etaxonomy.taxeditor.store.CdmStore;

/**
 * @author k.luther
 * @since 03.12.2019
 */
public class NamedAreaTermDtoContentProvider extends TermDtoContentProvider {

    @Override
    public Collection<? extends TermDto> getChildTerms(TermVocabularyDto voc) {
        Collection<TermDto> children = getVocabularyToChildTermMap().get(voc);
        if(children==null){
            children = new ArrayList<>(CdmStore.getService(IVocabularyService.class).getCompleteTermHierarchy(voc));
            getVocabularyToChildTermMap().put(voc, children);
        }
        return children;
    }

}
