package eu.etaxonomy.taxeditor.ui.dialog.selection;

import org.eclipse.jface.viewers.LabelProvider;
import org.eclipse.swt.widgets.Shell;

import eu.etaxonomy.cdm.api.service.IIdentifiableEntityService;
import eu.etaxonomy.cdm.api.service.dto.IdentifiedEntityDTO;
import eu.etaxonomy.cdm.model.common.ICdmBase;
import eu.etaxonomy.cdm.model.metadata.PreferencePredicate;
import eu.etaxonomy.cdm.model.term.DefinedTerm;
import eu.etaxonomy.cdm.persistence.query.MatchMode;
import eu.etaxonomy.taxeditor.preference.PreferencesUtil;
import eu.etaxonomy.taxeditor.store.CdmStore;

public abstract class AbstractFilteredIdentifierSelectionDialog<T extends ICdmBase>
        extends AbstractFilteredCdmResourceSelectionDialog<T> {

    private DefinedTerm identifierType;
    private MatchMode matchMode;
    private Class<T> type;

    protected AbstractFilteredIdentifierSelectionDialog(Shell shell, String title, boolean multi,
            String settings, T cdmObject) {
        super(shell, title, multi, settings, cdmObject);
    }

    public class FilteredIdentifiedEntityLabelProvider extends LabelProvider {
		@Override
		public String getText(Object element) {
			if (element == null) {
				return null;
			}
			IdentifiedEntityDTO identifiedEntity = (IdentifiedEntityDTO) element;
			String titleCache = identifiedEntity.getCdmEntity().getTitleCache();
			if(PreferencesUtil.getBooleanValue(PreferencePredicate.ShowIdInSelectionDialog.getKey())){
			    titleCache += " ["+identifiedEntity.getCdmEntity().getUuid()+"]";
			}
			// add identifier
			titleCache += " ["+identifiedEntity.getIdentifier().getIdentifier()+"]";
            return titleCache;
		}
	}

	@Override
	protected void callService(String pattern){
	    model = CdmStore.getService(IIdentifiableEntityService.class).listByIdentifier(type, pattern, identifierType, matchMode, true, null, limitOfInitialElements);
	}
}