/**
* Copyright (C) 2018 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.ui.dialog.selection;

import org.eclipse.swt.widgets.Shell;

import eu.etaxonomy.cdm.api.service.IReferenceService;
import eu.etaxonomy.cdm.model.common.MarkerType;
import eu.etaxonomy.cdm.model.reference.Reference;
import eu.etaxonomy.taxeditor.newWizard.AbstractNewEntityWizard;
import eu.etaxonomy.taxeditor.newWizard.NewCommonNameReferenceWizard;
import eu.etaxonomy.taxeditor.store.CdmStore;

/**
 * @author k.luther
 * @since 26.09.2018
 *
 */
public class CommonNameReferenceSelectionDialog extends ReferenceSelectionDialog {

    /**
     * @param shell
     * @param title
     * @param multi
     * @param reference
     */
    protected CommonNameReferenceSelectionDialog(Shell shell, String title, boolean multi, Reference reference) {
        super(shell, title, multi, reference, null);

    }


    /* (non-Javadoc)
     * @see eu.etaxonomy.taxeditor.dialogs.AbstractFilteredCdmResourceSelectionDialog#search
     */
    /** {@inheritDoc} */
    @Override
    protected void callService(String pattern) {

        model = CdmStore.getService(IReferenceService.class).findUuidAndTitleCacheByMarker(100, pattern, MarkerType.COMMON_NAME_REFERENCE());


    }

    /**
     * <p>select</p>
     *
     * @param reference a {@link eu.etaxonomy.cdm.model.reference.ReferenceBase} object.
     * @param shell a {@link org.eclipse.swt.widgets.Shell} object.
     * @param conversation a {@link eu.etaxonomy.cdm.api.conversation.ConversationHolder} object.
     * @return a {@link eu.etaxonomy.cdm.model.reference.ReferenceBase} object.
     */

    public static Reference select(Shell shell, //ConversationHolder conversation,
            Reference reference) {
        CommonNameReferenceSelectionDialog dialog = new CommonNameReferenceSelectionDialog(shell,// conversation,
                "Choose a common name reference", isInReference, reference);
        return getSelectionFromDialog(dialog);
    }

    @Override
    protected AbstractNewEntityWizard getNewEntityWizard(String parameter) {
        return new NewCommonNameReferenceWizard(null);
    }

}
