/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.ui.dialog.selection;

import java.util.UUID;

import org.eclipse.swt.widgets.Shell;

import eu.etaxonomy.cdm.api.service.IAgentService;
import eu.etaxonomy.cdm.model.agent.AgentBase;
import eu.etaxonomy.cdm.model.agent.Institution;
import eu.etaxonomy.taxeditor.newWizard.AbstractNewEntityWizard;
import eu.etaxonomy.taxeditor.newWizard.NewInstitutionWizard;
import eu.etaxonomy.taxeditor.store.CdmStore;

/**
 * @author n.hoffmann
 * @created Dec 15, 2010
 */
public class InstitutionSelectionDialog extends
		AbstractFilteredCdmResourceSelectionDialog<Institution> {

	public static Institution select(Shell shell,
	        Institution institution){
		InstitutionSelectionDialog dialog = new InstitutionSelectionDialog(shell, //conversation,
				"Choose Institution", false, TeamSelectionDialog.class.getCanonicalName(), institution);
		return getSelectionFromDialog(dialog);
	}

	protected InstitutionSelectionDialog(Shell shell,
	        String title, boolean multi,
			String settings, Institution cdmObject) {
		super(shell, title, multi, settings, cdmObject);
	}

	@Override
	protected Institution getPersistentObject(UUID uuid) {
		AgentBase<?> agentBase = CdmStore.getService(IAgentService.class).load(uuid);

		if(agentBase instanceof Institution){
			return (Institution) agentBase;
		}
		return null;
	}

	@Override
	protected void callService(String pattern) {
	       model = CdmStore.getService(IAgentService.class)
	               .getUuidAndTitleCache(Institution.class, limitOfInitialElements, pattern);
	}

	@Override
	protected String[] getNewWizardText() {
		return new String[]{"New Institution"};
	}

	@Override
	protected AbstractNewEntityWizard<Institution> getNewEntityWizard(String parameter) {
		return new NewInstitutionWizard();
	}
}