/**
* Copyright (C) 2016 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.ui.dialog.selection;

import java.util.List;

import org.eclipse.swt.widgets.Shell;

import eu.etaxonomy.cdm.api.service.IAgentService;
import eu.etaxonomy.cdm.model.agent.Person;
import eu.etaxonomy.taxeditor.store.CdmStore;

/**
 * @author k.luther
 * @date 21.06.2016
 *
 */
public class NomenclaturalPersonAuthorSelectionDialog extends PersonSelectionDialog {

    /**
     * @param shell
     * @param conversation
     * @param title
     * @param multi
     * @param settings
     * @param agent
     */
    protected NomenclaturalPersonAuthorSelectionDialog(Shell shell, //ConversationHolder conversation,
            String title, boolean multi,
            String settings, Person agent) {
        super(shell, //conversation,
                title, multi, settings, agent);
        // TODO Auto-generated constructor stub
    }


    /**
     * <p>select</p>
     *
     * @param shell a {@link org.eclipse.swt.widgets.Shell} object.
     * @param conversation a {@link eu.etaxonomy.cdm.api.conversation.ConversationHolder} object.
     * @param entity a {@link eu.etaxonomy.cdm.model.agent.AgentBase} object.
     * @return a {@link eu.etaxonomy.cdm.model.agent.AgentBase} object.
     */
    public static Person select(Shell shell, //ConversationHolder conversation,
            Person entity, boolean teamMemberSelection) {
        NomenclaturalPersonAuthorSelectionDialog dialog = new NomenclaturalPersonAuthorSelectionDialog(shell,
                "Choose Agent", false, NomenclaturalAuthorSelectionDialog.class.getCanonicalName(), entity);
        return getSelectionFromDialog(dialog);
    }

    @Override
    protected void callService(String pattern) {
        model = (List)CdmStore.getService(IAgentService.class).getUuidAndAbbrevTitleCache(Person.class, limitOfInitialElements, pattern);
    }

}
