/**
* Copyright (C) 2017 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.ui.dialog.selection;

import java.util.UUID;

import org.eclipse.swt.widgets.Shell;

import eu.etaxonomy.cdm.api.service.IRightsService;
import eu.etaxonomy.cdm.hibernate.HibernateProxyHelper;
import eu.etaxonomy.cdm.model.media.Rights;
import eu.etaxonomy.taxeditor.model.MessagingUtils;
import eu.etaxonomy.taxeditor.newWizard.AbstractNewEntityWizard;
import eu.etaxonomy.taxeditor.store.CdmStore;

/**
 * @author k.luther
 * @date 15.02.2017
 *
 */
public class RightsSelectionDialog extends AbstractFilteredCdmResourceSelectionDialog<Rights> {


    public static Rights select(Shell shell, //ConversationHolder conversation,
            Rights rights){
        RightsSelectionDialog dialog = new RightsSelectionDialog(shell, //conversation,
                "Choose Rights", false, RightsSelectionDialog.class.getCanonicalName(), rights);
        return getSelectionFromDialog(dialog);
    }

    /**
     * <p>Constructor for FilteredDerivedUnitSelectionDialog.</p>
     */
    protected RightsSelectionDialog(Shell shell, //ConversationHolder conversation,
            String title,
            boolean multi, String settings, Rights rights) {
        super(shell, //conversation,
                title, multi, settings, rights);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    protected Rights getPersistentObject(UUID uuid) {
        Object object = CdmStore.getService(IRightsService.class).load(uuid);

        Rights rights= (Rights) HibernateProxyHelper.deproxy(object);

        if(rights != null){
            return rights;
        }
        MessagingUtils.error(this.getClass(), "Selected element is not rights", null);
        return null;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    protected String[] getNewWizardText() {
        return null;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    protected AbstractNewEntityWizard getNewEntityWizard(String parameter) {
        // TODO Auto-generated method stub
        return null;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    protected void callService(String pattern) {
        model = CdmStore.getService(IRightsService.class).getUuidAndLabelText(limitOfInitialElements,pattern);
    }

}
