// $Id$
/**
* Copyright (C) 2018 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.ui.dialog.selection;

import java.util.UUID;

import org.eclipse.swt.widgets.Shell;

import eu.etaxonomy.cdm.api.service.ITaxonService;
import eu.etaxonomy.cdm.model.taxon.Taxon;
import eu.etaxonomy.cdm.model.taxon.TaxonBase;
import eu.etaxonomy.taxeditor.newWizard.AbstractNewEntityWizard;
import eu.etaxonomy.taxeditor.newWizard.NewTaxonWizard;
import eu.etaxonomy.taxeditor.store.CdmStore;

/**
 * @author k.luther
 * @date 09.03.2018
 *
 */
public class TaxonSelectionDialog extends TaxonBaseSelectionDialog<Taxon> {



    /**
     * @param clazz
     * @param shell
     * @param title
     * @param multi
     * @param taxon
     * @param taxonToBeFiltered
     */
    protected TaxonSelectionDialog(Class<? extends TaxonBase> clazz, Shell shell, String title, boolean multi,
            TaxonBase taxon, TaxonBase taxonToBeFiltered) {
        super(clazz, shell, title, multi, taxon, taxonToBeFiltered);
        // TODO Auto-generated constructor stub
    }

    public static Taxon selectTaxon(Shell shell, //ConversationHolder conversation,
            Taxon taxonToBeFiltered) {
        AbstractFilteredCdmResourceSelectionDialog<Taxon> dialog = new TaxonSelectionDialog(Taxon.class, shell, //conversation,
                "Choose a taxon", false, null, taxonToBeFiltered);
        return getSelectionFromDialog(dialog);
    }


    @Override
    protected void callService(String pattern) {
        model = CdmStore.getService(ITaxonService.class).getUuidAndTitleCache(Taxon.class, limitOfInitialElements, pattern);
    }


    @Override
    protected Taxon getPersistentObject(UUID uuid) {
        return (Taxon) CdmStore.getService(ITaxonService.class).load(uuid);
    }

    /* (non-Javadoc)
     * @see eu.etaxonomy.taxeditor.ui.dialog.selection.AbstractFilteredCdmResourceSelectionDialog#getNewWizardText()
     */
    @Override
    protected String[] getNewWizardText() {
        return new String[]{"New Taxon"};
    }

    /* (non-Javadoc)
     * @see eu.etaxonomy.taxeditor.ui.dialog.selection.AbstractFilteredCdmResourceSelectionDialog#getNewEntityWizard(java.lang.String)
     */
    @Override
    protected AbstractNewEntityWizard getNewEntityWizard(String parameter) {
        return new NewTaxonWizard();
    }

}
