/**
* Copyright (C) 2019 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.ui.dialog.selection;

import java.util.List;

import org.eclipse.swt.widgets.Shell;

import eu.etaxonomy.cdm.api.service.IAgentService;
import eu.etaxonomy.cdm.model.agent.Person;
import eu.etaxonomy.cdm.model.agent.Team;
import eu.etaxonomy.cdm.model.agent.TeamOrPersonBase;
import eu.etaxonomy.taxeditor.store.CdmStore;

/**
 * @author k.luther
 * @since 18.03.2019
 */
public class TeamOrPersonBaseSelectionDialog
        extends AgentSelectionDialog<TeamOrPersonBase<?>>  {

    protected TeamOrPersonBaseSelectionDialog(Shell shell, String title, boolean multi, String settings,
            TeamOrPersonBase<?> agent, boolean selectTeamMember) {
        super(shell, title, multi, settings, agent, selectTeamMember);
    }

    public static TeamOrPersonBase<?> select(Shell shell,
            TeamOrPersonBase<?> entity, boolean selectTeamMember) {
        TeamOrPersonBaseSelectionDialog dialog = new TeamOrPersonBaseSelectionDialog(shell,
                "Choose Team or Person", false, TeamOrPersonBaseSelectionDialog.class.getCanonicalName(), entity, selectTeamMember);
        return getSelectionFromDialog(dialog);
    }

    @Override
    protected void callService(String pattern) {
    	model = (List)CdmStore.getService(IAgentService.class).getTeamOrPersonUuidAndTitleCache(null, limitOfInitialElements, pattern);
//        model = (List)CdmStore.getService(IAgentService.class).getUuidAndTitleCache(Team.class, limitOfInitialElements, pattern);
//        model.addAll((List)CdmStore.getService(IAgentService.class).getUuidAndTitleCache(Person.class,limitOfInitialElements, pattern));
    }

    @Override
    protected String getTitle(TeamOrPersonBase<?> cdmObject) {
        if(cdmObject == null){
            return "";
        }
        return cdmObject.getTitleCache();
    }
}