/**
* Copyright (C) 2021 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.ui.element;

import org.eclipse.swt.widgets.Composite;

/**
 * @author a.mueller
 * @since 19.01.2021
 */
public abstract class AbstractRelevanceFormElement
        extends AbstractCdmFormElement
        implements ICacheRelevantFormElement {

    protected CacheRelevanceHelper cacheRelevanceHelper = new CacheRelevanceHelper();

    protected AbstractRelevanceFormElement(CdmFormFactory formFactory, Composite layoutComposite) {
        super(formFactory, layoutComposite);
    }

    public AbstractRelevanceFormElement(CdmFormFactory formFactory, ICdmFormElement formElement) {
        super(formFactory, formElement);
    }

    @Override
    public void addDependsOnCache(ToggleableTextElement toggleElement) {
        cacheRelevanceHelper.addDependsOnCache(toggleElement);
    }

    @Override
    public CacheRelevance cacheRelevance() {
        return cacheRelevanceHelper.cacheRelevance();
    }
}
