/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.ui.element;

/**
 * IRelevantFormElement interface.
 *
 * @author n.hoffmann
 * @created May 10, 2010
 */
public interface ICacheRelevantFormElement {

	/**
	 * Update the relevance state of the element.
	 * Usually the results in a color change.
	 * Containers may sent this to their subelements.
	 */
	public void updateCacheRelevance();

	/**
	 * Registers this element as being dependend on the
	 * given cache element (ToggleableTextElement).
	 * An element may depend on multiple cache elements.
	 */
	public void addDependsOnCache(ToggleableTextElement toggleElement);

	/**
	 * Computes the cache relevance for this element.
	 * The cache relevance depends on the registered cache elements
	 * and on their state.
	 */
	public CacheRelevance cacheRelevance();

}