/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.ui.element;

/**
 * IEnableableFormElement interface.
 *
 * @author n.hoffmann
 * @created Mar 10, 2010
 */
public interface IEnableableFormElement {

	/**
	 * Sets composites of this element to the given enablement state.
	 *
	 * @param enabled a boolean.
	 */
	public abstract void setEnabled(boolean enabled);

	/**
	 * Return <code>true</code> if the element is enabled and <code>false</code> otherwise
	 * @return a boolean stating the current enablement value
	 */
	public boolean isEnabled();
}
