/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.ui.element;

/**
 * Any composite that represent a cdm entity should implement
 * this interface. Selection of CdmEntity data will rely on this
 * interface.
 *
 * @author n.hoffmann
 * @created Feb 16, 2010
 */
public interface IEntityElement<ENTITY> extends ICdmFormElement, ISelectable {

	/**
	 * Returns the entity of this composite.
	 *
	 * @param <ENTITY> a ENTITY object.
	 * @return a ENTITY object.
	 */
	public ENTITY getEntity();
}