/**
 * Copyright (C) 2007 EDIT
 * European Distributed Institute of Taxonomy
 * http://www.e-taxonomy.eu
 *
 * The contents of this file are subject to the Mozilla Public License Version 1.1
 * See LICENSE.TXT at the top of this package for the full license terms.
 */
package eu.etaxonomy.taxeditor.ui.element;

import org.eclipse.ui.forms.widgets.ExpandableComposite;

import eu.etaxonomy.cdm.model.common.TimePeriod;

/**
 * TimePeriodElement class.
 *
 * @author n.hoffmann
 * @created Nov 17, 2009
 */
public class TimePeriodElement
			extends TimePeriodElementBase<TimePeriod> implements IEnableableFormElement{
    boolean isEnabled = true;

    public TimePeriodElement(CdmFormFactory formFactory, ICdmFormElement parentElement, String labelString,
			TimePeriod timePeriod, int style) {
		super(formFactory, parentElement, labelString, timePeriod, style);
	}

	@Override
	protected DateDetailSection<TimePeriod> createDateDetailSection() {
		return formFactory.createDateDetailSection(this,
				ExpandableComposite.TWISTIE);
	}

    @Override
    public void setEnabled(boolean enabled) {
        this.isEnabled = enabled;
        for (ICdmFormElement element: getElements()){
            if (element instanceof IEnableableFormElement){
                IEnableableFormElement enableableElement = (IEnableableFormElement) element;
                enableableElement.setEnabled(enabled);
            }
        }

    }

    @Override
    public boolean isEnabled() {
        return isEnabled;
    }

}