/**
* Copyright (C) 2018 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.ui.element;

import org.eclipse.ui.forms.widgets.Section;

import eu.etaxonomy.cdm.model.common.VerbatimTimePeriod;

/**
 * @author k.luther
 * @since 15.05.2018
 */
public class VerbatimTimePeriodElement
			extends TimePeriodElementBase<VerbatimTimePeriod> {


    public VerbatimTimePeriodElement(CdmFormFactory formFactory, ICdmFormElement parentElement, String labelString,
			VerbatimTimePeriod timePeriod, int style) {
		super(formFactory, parentElement, labelString, timePeriod, style);
	}

	@Override
	protected DateDetailSection<VerbatimTimePeriod> createDateDetailSection() {
		return formFactory.createVerbatimDateDetailSection(this,
				Section.TWISTIE);
	}

    /**
     * Setter for the field <code>timePeriod</code>.
     */
    @Override
    public void setTimePeriod(VerbatimTimePeriod timePeriod) {
        super.setTimePeriod(timePeriod);
    }
}