/**
* Copyright (C) 2014 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.ui.mvc;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.ui.forms.widgets.FormToolkit;
import org.eclipse.ui.forms.widgets.TableWrapData;
import org.eclipse.ui.forms.widgets.TableWrapLayout;

import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
import eu.etaxonomy.taxeditor.ui.mvc.element.TextWithLabelElementMVC;

/**
 * @author pplitzner
 * @date 15.04.2014
 *
 */
public class GeographicPointElement extends AbstractCdmComposite {

    private final FormToolkit toolkit = new FormToolkit(Display.getCurrent());

    /**
     * Create the composite.
     * @param parent
     * @param style
     */
    public GeographicPointElement(Composite parent, int style) {
        super(parent, style);
        addDisposeListener(new DisposeListener() {
            @Override
            public void widgetDisposed(DisposeEvent e) {
                toolkit.dispose();
            }
        });
        toolkit.adapt(this);
        toolkit.paintBordersFor(this);
        {
            TableWrapLayout tableWrapLayout = new TableWrapLayout();
            tableWrapLayout.verticalSpacing = 0;
            tableWrapLayout.topMargin = 0;
            tableWrapLayout.rightMargin = 0;
            tableWrapLayout.leftMargin = 0;
            tableWrapLayout.bottomMargin = 0;
            tableWrapLayout.horizontalSpacing = 0;
            tableWrapLayout.numColumns = 2;
            setLayout(tableWrapLayout);
        }

        Label lblLatitude = toolkit.createLabel(this, "Latitude", SWT.NONE);
        new Label(this, SWT.NONE);

        Label lblLongitude = toolkit.createLabel(this, "Longitude", SWT.NONE);
        new Label(this, SWT.NONE);

        Label lblErrorRadius = toolkit.createLabel(this, "Error Radius", SWT.NONE);

        TextWithLabelElementMVC textWithLabelElement = new TextWithLabelElementMVC(this, (String) null, (Integer) null, 0);
        TableWrapData twd_textWithLabelElement = new TableWrapData(TableWrapData.LEFT, TableWrapData.TOP, 1, 1);
        twd_textWithLabelElement.grabHorizontal = true;
        textWithLabelElement.setLayoutData(twd_textWithLabelElement);
        toolkit.adapt(textWithLabelElement);
        toolkit.paintBordersFor(textWithLabelElement);

        Label lblReferenceSystem = toolkit.createLabel(this, "Reference System", SWT.NONE);

    }

    /* (non-Javadoc)
     * @see eu.etaxonomy.taxeditor.ui.mvc.AbstractCdmComposite#initInternalController(eu.etaxonomy.taxeditor.ui.element.CdmFormFactory, eu.etaxonomy.taxeditor.ui.element.ICdmFormElement)
     */
    @Override
    protected void initInternalController(CdmFormFactory formFactory, ICdmFormElement parentElement) {

    }

}
