/**
* Copyright (C) 2014 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.ui.mvc.interfaces;

import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;

/**
 * A composite for visualizing CDM objects. ICdmComposites are mere GUI composites but
 * they initialize a controller which contains the interaction logic.
 * @author pplitzner
 * @date 11.02.2014
 *
 */
public interface ICdmComposite {

    /**
     * Initializes the {@link CdmCompositeController} of this composite.
     * @param formFactory the factory used for the GUI element
     * @param parentElement the parent {@link ICdmFormElement}
     */
    public void initController(CdmFormFactory formFactory, ICdmFormElement parentElement);

    /**
     * Returns the {@link CdmCompositeController} of this composite.
     * @return
     */
    public CdmCompositeController getController();

}
