/**
* Copyright (C) 2018 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.ui.section;

import java.util.Comparator;

import eu.etaxonomy.cdm.model.common.CdmBase;

/**
 * @author pplitzner
 * @since Mar 5, 2018
 */
public class DefaultCdmBaseComparator<T extends CdmBase> implements Comparator<T> {

    @Override
    public int compare(T o1, T o2) {
        if(o1==null){
            return -1;
        }
        if(o2==null){
            return 1;
        }
        int diff = o1.getId() - o2.getId();
        if(diff==0){
            diff = o1.getCreated().compareTo(o2.getCreated());
        }
        return diff;
    }
}