/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.ui.section.agent;

import org.apache.commons.lang3.StringUtils;
import org.eclipse.swt.SWT;

import eu.etaxonomy.cdm.api.conversation.ConversationHolder;
import eu.etaxonomy.cdm.model.agent.AgentBase;
import eu.etaxonomy.cdm.model.agent.Person;
import eu.etaxonomy.taxeditor.ui.element.AbstractCdmEntityWizardPage;
import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
import eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailElement;

/**
 * <p>PersonWizardPage class.</p>
 *
 * @author n.hoffmann
 * @created Jun 1, 2010
 * @version 1.0
 */
public class PersonWizardPage extends AbstractCdmEntityWizardPage<Person> {

    PersonDetailElement personElement;


	/**
	 * <p>Constructor for PersonWizardPage.</p>
	 *
	 * @param formFactory a {@link eu.etaxonomy.taxeditor.ui.element.CdmFormFactory} object.
	 * @param conversation a {@link eu.etaxonomy.cdm.api.conversation.ConversationHolder} object.
	 * @param entity a {@link eu.etaxonomy.cdm.model.agent.Person} object.
	 */
	public PersonWizardPage(CdmFormFactory formFactory, ConversationHolder conversation,
			Person entity) {
		super(formFactory, conversation, entity);
		setTitle("Person");
	}


	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.forms.CdmEntityWizardPage#createElement(eu.etaxonomy.taxeditor.forms.ICdmFormElement)
	 */
	/** {@inheritDoc} */
	@Override
	public AbstractCdmDetailElement<Person> createElement(ICdmFormElement rootElement) {
		personElement = formFactory.createPersonDetailElement(rootElement, SWT.NULL);
		personElement.setEntity(entity);
		return personElement;
	}

	@Override
    protected boolean titleCacheIsNotEmpty() {
        if (getEntity() instanceof AgentBase) {
            return !StringUtils.isEmpty(entity.getTitleCache());
        }
        return true;
    }
}
