/**
* Copyright (C) 2019 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.ui.section.feature;

import org.eclipse.jface.wizard.Wizard;

import eu.etaxonomy.cdm.model.description.FeatureState;
import eu.etaxonomy.cdm.persistence.dto.FeatureStateDto;
import eu.etaxonomy.cdm.persistence.dto.TermNodeDto;
import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;

/**
 * @author pplitzner
 * @since Aug 16, 2019
 *
 */
public class FeatureStateWizard extends Wizard {

    private static final String CREATE_FEATURE_STATE = "Create Feature State";
    private FeatureStateWizardPage page;
    private CdmFormFactory formFactory;
    private TermNodeDto termNode;

    public FeatureStateWizard(TermNodeDto termNode, CdmFormFactory formFactory) {
        super();
        this.formFactory = formFactory;
        this.termNode = termNode;
        setWindowTitle(CREATE_FEATURE_STATE);
    }

    @Override
    public void addPages() {
        page = new FeatureStateWizardPage(CREATE_FEATURE_STATE, termNode, formFactory);
        addPage(page);
    }

    @Override
    public boolean performFinish() {
        return page.isPageComplete();
    }

    FeatureState getFeatureState(){
        return page.getFeatureState();
    }
    
    FeatureStateDto getFeatureStateDto(){
        return page.getFeatureStateDto();
    }

}
