/**
 *
 */
package eu.etaxonomy.taxeditor.ui.section.key;

import java.util.Collection;
import java.util.Comparator;

import eu.etaxonomy.cdm.api.conversation.ConversationHolder;
import eu.etaxonomy.cdm.model.term.DefinedTerm;
import eu.etaxonomy.cdm.model.description.PolytomousKey;
import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
import eu.etaxonomy.taxeditor.ui.section.DefaultCdmBaseComparator;
import eu.etaxonomy.taxeditor.ui.section.occurrence.dna.AbstractUnboundEntityCollectionSection;

/**
 * @author n.hoffmann
 *
 */
public class ScopeRestrictionSection extends AbstractUnboundEntityCollectionSection<PolytomousKey, DefinedTerm> {

	public ScopeRestrictionSection(CdmFormFactory formFactory,
			ConversationHolder conversation, ICdmFormElement parentElement, int style) {
		super(formFactory, conversation, parentElement, "Scope Restriction", style);
	}


	@Override
	protected Collection<DefinedTerm> getEntityCollection(PolytomousKey entity) {
		return entity.getScopeRestrictions();
	}

	@Override
	public Comparator<DefinedTerm> getComparator() {
        return new DefaultCdmBaseComparator<>();
	}

	@Override
	public DefinedTerm createNewElement() {
		return null;

	}

	@Override
	public void addElement(DefinedTerm element) {
		getEntity().addScopeRestriction(element);
	}

	@Override
	public void removeElement(DefinedTerm element) {
		getEntity().removeScopeRestriction(element);
	}

	@Override
	public String getEmptyString() {
		return "No scope restrictions yet.";
	}

	@Override
	protected String getTooltipString() {
		return "Add a scope restriction";
	}


    /**
     * {@inheritDoc}
     */
    @Override
    public DefinedTerm addExisting() {
        // TODO Auto-generated method stub
        return null;
    }


    /**
     * {@inheritDoc}
     */
    @Override
    public boolean allowAddExisting() {
        // TODO Auto-generated method stub
        return false;
    }

}
