/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.ui.section.name;

import org.eclipse.jface.viewers.ISelectionProvider;

import eu.etaxonomy.cdm.api.conversation.ConversationHolder;
import eu.etaxonomy.cdm.hibernate.HibernateProxyHelper;
import eu.etaxonomy.cdm.model.name.INonViralName;
import eu.etaxonomy.cdm.model.name.TaxonName;
import eu.etaxonomy.cdm.model.taxon.TaxonBase;
import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
import eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailElement;
import eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailSection;
import eu.etaxonomy.taxeditor.ui.section.ITaxonBaseDetailSection;

/**
 * @author n.hoffmann
 * @created 05.06.2009
 */
public class AuthorshipDetailSection extends AbstractCdmDetailSection<INonViralName> implements ITaxonBaseDetailSection {

	private TaxonBase<?> taxonBase;

	public AuthorshipDetailSection(CdmFormFactory cdmFormFactory, ConversationHolder conversation, ICdmFormElement parentElement,
			ISelectionProvider selectionProvider, int style) {
		super(cdmFormFactory, conversation, parentElement, selectionProvider, style);
	}

	@Override
    public void setTaxonBase(TaxonBase entity) {
		this.taxonBase = entity;
		INonViralName name = HibernateProxyHelper.deproxy(entity.getName());
		setEntity(name);
	}

	@Override
	public String getHeading() {
		return "Authorship";
	}

	@Override
	public TaxonBase getTaxonBase() {
		return taxonBase;
	}

	@Override
	protected void setSectionTitle() {
        String title = "";
        String label = "";
        if (getEntity() != null && (getEntity() instanceof TaxonName) ) {
            label =((TaxonName) getEntity()).getAuthorshipCache();
            title = ": " + label;
        }
        this.setText(String.format("%s%s", getHeading(), title));
        setTextClient(createToolbar());
    }

	@Override
	protected AbstractCdmDetailElement<INonViralName> createCdmDetailElement(
			AbstractCdmDetailSection<INonViralName> parentElement, int style) {
	    return formFactory.createAuthorshipDetailElement(parentElement, style);
	}

	public void updateContent(){
		((AuthorshipDetailElement)this.detailElement).updateContent();
	}
}