/**
 * Copyright (C) 2007 EDIT
 * European Distributed Institute of Taxonomy
 * http://www.e-taxonomy.eu
 *
 * The contents of this file are subject to the Mozilla Public License Version 1.1
 * See LICENSE.TXT at the top of this package for the full license terms.
 */
package eu.etaxonomy.taxeditor.ui.section.occurrence;

import org.eclipse.swt.events.SelectionListener;

import eu.etaxonomy.cdm.model.location.NamedArea;
import eu.etaxonomy.taxeditor.ui.element.AbstractFormSection;
import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
import eu.etaxonomy.taxeditor.ui.section.AbstractEntityCollectionElement;
import eu.etaxonomy.taxeditor.ui.selection.EntitySelectionElement;

/**
 * @author n.hoffmann
 * @created Oct 14, 2010
 */
public class CollectingAreaDetailElement extends
		AbstractEntityCollectionElement<NamedArea> {

	private EntitySelectionElement<NamedArea> selection_namedArea;

	/**
	 * <p>
	 * Constructor for CollectingAreasDetailElement.
	 * </p>
	 *
	 * @param formFactory
	 *            a {@link eu.etaxonomy.taxeditor.ui.element.CdmFormFactory}
	 *            object.
	 * @param section
	 *            a {@link eu.etaxonomy.taxeditor.ui.element.AbstractFormSection}
	 *            object.
	 * @param entity
	 *            a {@link eu.etaxonomy.cdm.model.location.NamedArea} object.
	 * @param removeListener
	 *            a {@link org.eclipse.swt.events.SelectionListener} object.
	 * @param style
	 *            a int.
	 */
	public CollectingAreaDetailElement(CdmFormFactory formFactory,
			AbstractFormSection section, NamedArea entity,
			SelectionListener removeListener, int style) {
		super(formFactory, section, entity, removeListener, null, style);
	}

	@Override
	public void setEntity(NamedArea entity) {
		this.entity = entity;
		if (selection_namedArea != null){
			selection_namedArea.setEntity(entity);
		}
	}

	@Override
	public void createControls(ICdmFormElement formElement, int style) {
		selection_namedArea = formFactory.createSelectionElement(NamedArea.class, //getConversationHolder(),
				formElement, "Area",
				null, EntitySelectionElement.NOTHING, style);
		if (entity != null){
			setEntity(entity);
		}
	}

	@Override
	public void handleEvent(Object eventSource) {
		if (eventSource == selection_namedArea) {
			setEntity(selection_namedArea.getSelection());
		}
	}
}
