/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.ui.section.occurrence;

import eu.etaxonomy.cdm.model.occurrence.SpecimenOrObservationBase;
import eu.etaxonomy.taxeditor.store.StoreUtil;
import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
import eu.etaxonomy.taxeditor.ui.element.LayoutConstants;
import eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailElement;

/**
 * @author n.hoffmann
 * @created May 11, 2011
 */
public class DeterminationDetailElement extends AbstractCdmDetailElement<SpecimenOrObservationBase> {

	private CurrentDeterminationDetailSection section_currentDetermination;

	private DeterminationHistoryDetailSection section_determinationHistory;

	public DeterminationDetailElement(CdmFormFactory formFactory,
			ICdmFormElement formElement) {
		super(formFactory, formElement);
	}

	@Override
	protected void createControls(ICdmFormElement formElement,
	        SpecimenOrObservationBase entity, int style) {

        section_currentDetermination = formFactory.createCurrentDeterminationDetailSection(
                getConversationHolder(), formElement, StoreUtil.getSectionStyle(CurrentDeterminationDetailSection.class, entity.getClass().getCanonicalName(), true));
        section_currentDetermination.setLayoutData(LayoutConstants.FILL_HORIZONTALLY(2, 1));
        section_currentDetermination.setEntity(entity);

        section_determinationHistory = formFactory.createDeterminationHistoryDetailSection(
                getConversationHolder(), formElement, StoreUtil.getSectionStyle(DeterminationHistoryDetailSection.class, entity.getClass().getCanonicalName()));
        section_determinationHistory.setLayoutData(LayoutConstants.FILL_HORIZONTALLY(2, 1));
        section_determinationHistory.setEntity(entity);
	}

	@Override
	public void handleEvent(Object eventSource) {
		if(eventSource == section_currentDetermination){
			section_determinationHistory.refresh();
		}
	}
}