package eu.etaxonomy.taxeditor.ui.section.reference;

import eu.etaxonomy.cdm.model.name.NomenclaturalSource;
import eu.etaxonomy.cdm.model.taxon.SecundumSource;
import eu.etaxonomy.cdm.model.taxon.TaxonBase;
import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
import eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailElement;

public class SecundumSourceDetailElement extends AbstractCdmDetailElement<TaxonBase> {
	
	private SecundumSourceElement sourceElement;
	
	public SecundumSourceDetailElement(CdmFormFactory formFactory, ICdmFormElement formElement) {
		super(formFactory, formElement);
		
	}

	@Override
	protected void createControls(ICdmFormElement formElement, TaxonBase entity, int style) {
		sourceElement = formFactory.createSecundumSourceElement(formElement, entity, "Secundum");
	    if (entity.getSecSource() == null){
            SecundumSource source = SecundumSource.NewSecundumInstance(entity);
            entity.setSecSource(source);
            sourceElement.setEntity(source);
        }else{
            sourceElement.setEntity(entity.getSecSource());
        }
	    sourceElement.setPersistentBackground(formElement.getPersistentBackground());
		
	}

	@Override
	public void handleEvent(Object eventSource) {
		
		
	}

}
