/**
* Copyright (C) 2019 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.ui.section.supplemental;

import org.eclipse.swt.events.SelectionListener;

import eu.etaxonomy.cdm.model.common.SourcedEntityBase;
import eu.etaxonomy.taxeditor.ui.element.AbstractFormSection;
import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
import eu.etaxonomy.taxeditor.ui.element.ISelectableElement;
import eu.etaxonomy.taxeditor.ui.element.SelectionArbitrator;
import eu.etaxonomy.taxeditor.ui.section.AbstractEntityCollectionElement;

/**
 * @author k.luther
 * @since 26 Feb 2019
 *
 */
public abstract class AbstractSourcedEntityBaseElement<T extends SourcedEntityBase> extends AbstractEntityCollectionElement<T> implements ISelectableElement{

    private SelectionArbitrator selectionArbitrator;

    public AbstractSourcedEntityBaseElement(CdmFormFactory formFactory, AbstractFormSection section, T entity,
            SelectionListener removeListener, int style) {
        super(formFactory, section, entity, removeListener, null, style);
        // make this element selectable
        if(formFactory.getSelectionProvider() != null){
            selectionArbitrator = formFactory.createSelectionArbitrator(this);
        }
    }

    @Override
    public SelectionArbitrator getSelectionArbitrator() {
       return selectionArbitrator;
    }

    @Override
    public void setEntity(T entity) {
        this.entity = entity;
    }
}
