package eu.etaxonomy.taxeditor.ui.section.supplemental.identifier;

import eu.etaxonomy.cdm.api.conversation.ConversationHolder;
import eu.etaxonomy.cdm.model.common.Identifier;
import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
import eu.etaxonomy.taxeditor.ui.section.AbstractEntityCollectionSection;

public abstract class AbstractIdentifierSection<T> extends AbstractEntityCollectionSection<T, Identifier> {

	public AbstractIdentifierSection(CdmFormFactory formFactory,
			ConversationHolder conversation, ICdmFormElement parentElement, int style) {
		super(formFactory, conversation, parentElement, "Identifiers", style);
	}

	/** {@inheritDoc} */
	@Override
	public Identifier createNewElement() {
		return Identifier.NewInstance(null, null);
	}

	/** {@inheritDoc} */
	@Override
	public String getEmptyString() {
		return "No identifiers yet.";
	}

	/** {@inheritDoc} */
	@Override
	protected String getTooltipString() {
		return "Add an identifier";
	}

}
