/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.ui.section.taxon;

import org.eclipse.swt.SWT;

import eu.etaxonomy.cdm.api.conversation.ConversationHolder;
import eu.etaxonomy.cdm.model.taxon.TaxonBase;
import eu.etaxonomy.taxeditor.ui.element.AbstractCdmEntityWizardPage;
import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
import eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailElement;

/**
 * @author pplitzner
 * @date Jan 18, 2016
 */
public class TaxonWizardPage extends AbstractCdmEntityWizardPage<TaxonBase<?>> {

	public TaxonWizardPage(CdmFormFactory formFactory, ConversationHolder conversation,
	        TaxonBase<?> entity) {
		super(formFactory, conversation, entity);
		setTitle("Taxon");
	}

	@Override
	public AbstractCdmDetailElement<TaxonBase<?>> createElement(ICdmFormElement rootElement) {
		TaxonBaseDetailElement taxonBaseDetailElement = formFactory.createTaxonBaseDetailElement(rootElement, SWT.NULL);
		taxonBaseDetailElement.setEntity(entity);
		return taxonBaseDetailElement;
	}

	@Override
	public boolean isPageComplete() {
	    return true;
	}
}
