package eu.etaxonomy.taxeditor.ui.section.user;

import org.eclipse.swt.events.SelectionListener;

import eu.etaxonomy.cdm.model.permission.Group;
import eu.etaxonomy.cdm.model.permission.User;
import eu.etaxonomy.taxeditor.ui.element.AbstractFormSection;
import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
import eu.etaxonomy.taxeditor.ui.section.AbstractEntityCollectionElement;
import eu.etaxonomy.taxeditor.ui.selection.EntitySelectionElement;

/**
 *
 * @author n.hoffmann
 * @created Mar 10, 2011
 * @version 1.0
 */
public class GroupsByUserDetailElement extends
		AbstractEntityCollectionElement<Group> {

	private EntitySelectionElement<Group> selection_group;

	/**
	 * @param formFactory
	 * @param section
	 * @param entity
	 * @param removeListener
	 * @param backgroundColor
	 * @param style
	 */
	public GroupsByUserDetailElement(CdmFormFactory formFactory,
			AbstractFormSection section, Group entity,
			SelectionListener removeListener, int style) {
		super(formFactory, section, entity, removeListener, null, style);
	}

	/*
	 * (non-Javadoc)
	 *
	 * @see
	 * eu.etaxonomy.taxeditor.ui.section.AbstractEntityCollectionElement#setEntity
	 * (java.lang.Object)
	 */
	@Override
	public void setEntity(Group entity) {
	    User user = ((GroupsByUserDetailSection)this.getParentElement()).getEntity();
	    user.getGroups().remove(this.entity);
		this.entity = entity;
		user.getGroups().add(entity);
	}

	/*
	 * (non-Javadoc)
	 *
	 * @see eu.etaxonomy.taxeditor.ui.section.AbstractEntityCollectionElement#
	 * createControls(eu.etaxonomy.taxeditor.ui.forms.ICdmFormElement, int)
	 */
	@Override
	public void createControls(ICdmFormElement element, int style) {
		selection_group = formFactory
				.createSelectionElement(Group.class,//getConversationHolder(),
				        element, "", getEntity(),
						EntitySelectionElement.NOTHING, style);
	}

	/*
	 * (non-Javadoc)
	 *
	 * @see
	 * eu.etaxonomy.taxeditor.ui.section.AbstractEntityCollectionElement#handleEvent
	 * (java.lang.Object)
	 */
	@Override
	public void handleEvent(Object eventSource) {
		if (eventSource == selection_group) {
			setEntity(selection_group.getEntity());
		}
	}
}
