/**
 *
 */
package eu.etaxonomy.taxeditor.ui.section.user;

import eu.etaxonomy.cdm.api.conversation.ConversationHolder;
import eu.etaxonomy.cdm.model.permission.User;
import eu.etaxonomy.taxeditor.ui.element.AbstractCdmEntityWizardPage;
import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
import eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailElement;

/**
 * @author n.hoffmann
 *
 */
public class UserDetailWizardPage extends AbstractCdmEntityWizardPage<User> {

	public UserDetailWizardPage(CdmFormFactory formFactory,
			ConversationHolder conversation, User entity) {
		super(formFactory, conversation, entity);
		setTitle("User");
	}

	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.ui.forms.AbstractCdmEntityWizardPage#createElement(eu.etaxonomy.taxeditor.ui.forms.ICdmFormElement)
	 */
	@Override
	public AbstractCdmDetailElement<User> createElement(ICdmFormElement rootElement) {
		UserDetailElement userElement = formFactory.createUserDetailElement(rootElement);
		userElement.setEntity(getEntity());
		return userElement;
	}

	@Override
	protected void checkComplete() {
		boolean hasUsername = getEntity().getUsername() != null;
		setPageComplete(hasUsername);
	};

}
