/**
* Copyright (C) 2011 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.ui.section.userecords;

import org.eclipse.jface.viewers.ISelectionProvider;

import eu.etaxonomy.cdm.api.conversation.ConversationHolder;
import eu.etaxonomy.cdm.model.description.DescriptionElementBase;
import eu.etaxonomy.taxeditor.store.CdmStore;
import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
import eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailElement;
import eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailSection;

/**
 * UseRecordDetailSection Class
 * @author a.theys
 * @created mar 13, 2012
 * @version 1.0
 */
public class UseRecordDetailSection extends AbstractCdmDetailSection<DescriptionElementBase> {

	/**Constructor for class UseRecordDetailSection
	 *
	 * @param cdmFormFactory
	 * @param conversation
	 * @param parentElement
	 * @param selectionProvider
	 * @param style
	 */
	public UseRecordDetailSection(CdmFormFactory cdmFormFactory, ConversationHolder conversation,
			ICdmFormElement parentElement, ISelectionProvider selectionProvider, int style) {
		super(cdmFormFactory, conversation, parentElement, selectionProvider, style);
	}

	/** {@inheritDoc} */
	@Override
	public String getHeading() {
		return "Use Record";
	}

	/** {@inheritDoc} */
	@Override
	protected void setSectionTitle() {
		this.setText(getHeading() + ": " + getEntity().getFeature().getLabel(CdmStore.getDefaultLanguage()));
		setTextClient(createToolbar());
	}

	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailSection#createCdmDetailElement(eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailSection, int)
	 */
	@Override
	protected AbstractCdmDetailElement createCdmDetailElement(AbstractCdmDetailSection<DescriptionElementBase> parentElement, int style) {
	    return formFactory.createUseRecordDetailElement(parentElement);
	}

}
