/**
* Copyright (C) 2009 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.ui.section.vocabulary;

import org.apache.commons.lang3.StringUtils;

import eu.etaxonomy.cdm.model.term.DefinedTermBase;
import eu.etaxonomy.cdm.model.term.TermVocabulary;
import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
import eu.etaxonomy.taxeditor.ui.element.TextWithLabelElement;

/**
 * @author l.morris
 * @date 20 Dec 2011
 */
public class DefinedTermDetailElement<T extends DefinedTermBase> 
			extends AbstractTermBaseDetailElement<T> {

    protected TextWithLabelElement textIdInVocabulary;

    protected TextWithLabelElement textSymbol;

    protected TextWithLabelElement textSymbol2;

	/**
	 * @param formFactory
	 * @param formElement
	 */
	public DefinedTermDetailElement(CdmFormFactory formFactory,
			ICdmFormElement formElement) {
		super(formFactory, formElement);
	}

	@Override
    protected void createControls(ICdmFormElement formElement, T entity, int style) {
	    super.createControls(formElement, entity, style);
	    textIdInVocabulary = formFactory.createTextWithLabelElement(formElement, "ID in vocabulary", entity.getIdInVocabulary(), style);
	    textSymbol = formFactory.createTextWithLabelElement(formElement, "Symbol", entity.getSymbol(), style);
	    textSymbol2 = formFactory.createTextWithLabelElement(formElement, "Symbol 2", entity.getSymbol2(), style);
	};

	@Override
	public void handleEvent(Object eventSource) {
	    super.handleEvent(eventSource);
		//handleRepresentation(eventSource);
		if(eventSource==textIdInVocabulary){
			if (StringUtils.isBlank(textIdInVocabulary.getText())){
				getEntity().setIdInVocabulary(null);
			}else{
				getEntity().setIdInVocabulary(textIdInVocabulary.getText());
			}

		}
		if(eventSource==textSymbol){
            if (StringUtils.isBlank(textSymbol.getText())){
                getEntity().setSymbol(null);
            }else{
                getEntity().setSymbol(textSymbol.getText());
            }

        }

		if(eventSource==textSymbol2){
            if (StringUtils.isBlank(textSymbol2.getText())){
                getEntity().setSymbol2(null);
            }else{
                getEntity().setSymbol2(textSymbol2.getText());
            }

        }
	}

	@Override
	public TermVocabulary getVocabulary() {
		return getEntity() != null ? getEntity().getVocabulary() : null;
	}

}
