/**
 *
 */
package eu.etaxonomy.taxeditor.ui.section.vocabulary;

import java.util.Collection;
import java.util.Comparator;

import eu.etaxonomy.cdm.api.conversation.ConversationHolder;
import eu.etaxonomy.cdm.model.media.Media;
import eu.etaxonomy.cdm.model.term.DefinedTermBase;
import eu.etaxonomy.taxeditor.ui.dialog.selection.MediaSelectionDialog;
import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
import eu.etaxonomy.taxeditor.ui.section.AbstractEntityCollectionSection;
import eu.etaxonomy.taxeditor.ui.section.DefaultCdmBaseComparator;

/**
 *
 * @author pplitzner
 * @since May 17, 2019
 *
 */
public class TermMediaSection extends AbstractEntityCollectionSection<DefinedTermBase, Media>{

	public TermMediaSection(CdmFormFactory cdmFormFactory, ConversationHolder conversation, ICdmFormElement parentElement, int style) {
		super(cdmFormFactory, conversation, parentElement, "Media", style);
	}

	@Override
	public Media createNewElement() {
		return Media.NewInstance();
	}

	@Override
	public Collection<Media> getCollection(DefinedTermBase entity) {
		return entity.getMedia();
	}

	@Override
	public Comparator<Media> getComparator() {
        return new DefaultCdmBaseComparator<>();
	}

	@Override
	public String getEmptyString() {
		return "No media yet.";
	}

	@Override
	protected String getTooltipString() {
		return "Create new media";
	}

	@Override
	public void addElement(Media element) {
		getEntity().addMedia(element);
	}

	@Override
	public void removeElement(Media element) {
		getEntity().removeMedia(element);
	}

    @Override
    public Media addExisting() {
        return MediaSelectionDialog.select(getShell(), null);
    }

    @Override
    public boolean allowAddExisting() {
        return true;
    }

}
