/**
* Copyright (C) 2009 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.ui.section.vocabulary;

import eu.etaxonomy.cdm.model.term.TermVocabulary;
import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
import eu.etaxonomy.taxeditor.ui.element.UriWithLabelElement;

/**
 * @author l.morris
 * @date 20 Dec 2011
 */
public class TermVocabularyDetailElement extends AbstractTermBaseDetailElement<TermVocabulary> {

	private UriWithLabelElement uri_uriTermSource;
	public TermVocabularyDetailElement(CdmFormFactory formFactory,
			ICdmFormElement formElement) {
		super(formFactory, formElement);
	}

	@Override
	protected void createControls(ICdmFormElement formElement,
			TermVocabulary entity, int style) {

		super.createControls(formElement, entity, style);
		uri_uriTermSource = formFactory.createUriWithLabelElement(formElement, "Term Source URI", getEntity().getTermSourceUri(), style);
	}

	@Override
	public void handleEvent(Object eventSource) {
	    super.handleEvent(eventSource);

		if (eventSource == uri_uriTermSource) {
			getEntity().setTermSourceUri(uri_uriTermSource.parseText());
		}
	}

	@Override
	public TermVocabulary getVocabulary() {
		return getEntity();
	}

}
