package eu.etaxonomy.taxeditor.ui.selection;

import org.eclipse.swt.events.SelectionEvent;

import eu.etaxonomy.cdm.model.agent.AgentBase;
import eu.etaxonomy.cdm.model.agent.Person;
import eu.etaxonomy.cdm.model.agent.Team;
import eu.etaxonomy.cdm.model.agent.TeamOrPersonBase;
import eu.etaxonomy.cdm.model.common.CdmBase;
import eu.etaxonomy.cdm.model.reference.Reference;
import eu.etaxonomy.taxeditor.store.StoreUtil;
import eu.etaxonomy.taxeditor.ui.dialog.selection.SelectionDialogFactory;
import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;

public class CollectorSelectionElement extends EntitySelectionElement<AgentBase> {
	
	Team collectorTeam;
	/**
     * @param formFactory
     * @param conversation
     * @param parentElement
     * @param clazz
     * @param labelString
     * @param entity
     * @param mode
     * @param style
     */
    public CollectorSelectionElement(CdmFormFactory formFactory,// ConversationHolder conversation,
            ICdmFormElement parentElement, String labelString, AgentBase entity, int mode, int style) {
    	super(formFactory, //conversation,
        parentElement, AgentBase.class,
        labelString, entity, mode, style);
    }
    public CollectorSelectionElement(CdmFormFactory formFactory,// ConversationHolder conversation,
            ICdmFormElement parentElement, String labelString, AgentBase entity, Person primaryCollector, int mode, int style) {
    	super(formFactory, //conversation,
        parentElement, AgentBase.class,
        labelString, primaryCollector, mode, style);
    	if (entity instanceof Team){
    		collectorTeam = (Team)entity;
    	}
    }

    @Override
    protected String getTitle() {
		if (entity != null){
			if (entity instanceof TeamOrPersonBase){
				return ((TeamOrPersonBase)entity).getCollectorTitleCache();		  
			}else{
				return entity.getTitleCache();
			}
		}
		return "";
	}
	public Team getCollectorTeam() {
		return collectorTeam;
	}
	public void setCollectorTeam(Team collectorTeam) {
		this.collectorTeam = collectorTeam;
	}
	
	public void widgetSelected(SelectionEvent e) {
	    if (e.getSource().equals(button_selection) ){
	    	AgentBase selection = null;
	    	if (this.collectorTeam != null){
	    		selection = SelectionDialogFactory.getSelectionFromDialog(AgentBase.class, getShell(),
		                collectorTeam, this);
	    	}else{	    	
	    		selection = SelectionDialogFactory.getSelectionFromDialog(AgentBase.class, getShell(),
	                getEntity(), getParentElement());
	    	}
            setSelectionInternal(selection);
            if(!getLayoutComposite().isDisposed()){
                StoreUtil.reflowParentScrolledForm(getLayoutComposite(), true);
            }
	    }
	}
}
