/**
* Copyright (C) 2020 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.ui.selection;

import eu.etaxonomy.cdm.model.common.IIdentifiableEntity;
import eu.etaxonomy.cdm.model.location.NamedArea;
import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;

/**
 * @author k.luther
 * @since Apr 3, 2020
 */
public class EntitySelectionElementWithIdInVocabulary extends EntitySelectionElement<NamedArea> {

    /**
     * @param formFactory
     * @param parentElement
     * @param clazz
     * @param labelString
     * @param entity
     * @param mode
     * @param style
     */
    public EntitySelectionElementWithIdInVocabulary(CdmFormFactory formFactory, ICdmFormElement parentElement,
            Class<NamedArea> clazz, String labelString, NamedArea namedArea, int mode, int style) {
        super(formFactory, parentElement, clazz, labelString, namedArea, mode, style);
    }

    /**
     * <p>
     * getTitle
     * </p>
     *
     * @return a {@link java.lang.String} object.
     */
    @Override
    protected String getTitle() {
        if (entity != null){
            if(entity instanceof NamedArea){
                return entity.getIdInVocabulary() + " - "+entity.getLabel();
            }
            else if(entity instanceof IIdentifiableEntity) {
                return ((IIdentifiableEntity) entity).getTitleCache();
            }

        }
        return "";
    }




}
