/**
 * Copyright (C) 2015 EDIT
 * European Distributed Institute of Taxonomy
 * http://www.e-taxonomy.eu
 *
 * The contents of this file are subject to the Mozilla Public License Version 1.1
 * See LICENSE.TXT at the top of this package for the full license terms.
 */
package eu.etaxonomy.taxeditor.view;

import eu.etaxonomy.cdm.model.common.ICdmBase;
import eu.etaxonomy.cdm.persistence.dto.UuidAndTitleCache;

/**
 * @author a.mueller
 * @date 01.04.2021
 */
public class DtoWithEntity<S extends ICdmBase> extends UuidAndTitleCache<S> {

    private static final long serialVersionUID = -7400373251065982668L;

    private S entity;

    public DtoWithEntity(S entity) {
        super((Class<? extends S>)entity.getClass(), entity.getUuid(), entity.getId(), null);
        this.setEntity(entity);
    }

    public S getEntity() {
        return entity;
    }
    public void setEntity(S entity) {
        this.entity = entity;
    }
}
