/**
* Copyright (C) 2017 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.view.dataimport.e4.handler;

import org.eclipse.e4.core.contexts.ContextInjectionFactory;
import org.eclipse.e4.core.contexts.IEclipseContext;
import org.eclipse.e4.core.di.annotations.Execute;
import org.eclipse.jface.wizard.WizardDialog;
import org.eclipse.swt.widgets.Shell;

import eu.etaxonomy.taxeditor.view.dataimport.e4.SpecimenSearchWizard;

/**
 * @author pplitzner
 * @since Oct 4, 2017
 *
 */
public class OpenSpecimenImportWizard {

    @Execute
    public void execute(IEclipseContext ctx, Shell s)
    {
        SpecimenSearchWizard wizard = ContextInjectionFactory.make(SpecimenSearchWizard.class, ctx);
        wizard.init();
        WizardDialog dialog = new WizardDialog(s, wizard);
        dialog.open();
    }
}
