/**
* Copyright (C) 2019 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.view.search.facet;

import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;

/**
 * @author pplitzner
 * @since Feb 14, 2019
 *
 */
public abstract class CheckBoxSearchResultComposite<T, S extends SearchResult<T>> extends Composite {

    protected S result;
    private Button btnCheck;



    public CheckBoxSearchResultComposite(S result, Composite parent, int style) {
        super(parent, style);
        this.result = result;
        setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false));
        GridLayout gridLayout = new GridLayout();
        gridLayout.marginWidth = 0;
        gridLayout.horizontalSpacing = 0;
        gridLayout.numColumns = 2;
        setLayout(gridLayout);

        Composite composite = new Composite(this, SWT.NONE);
        composite.setLayout(new GridLayout(1, false));
        composite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));

        btnCheck = new Button(composite, SWT.CHECK);
        btnCheck.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, false, false, 1, 1));
        createContent(this);

    }

    public abstract Composite createContent(Composite parent);

    public S getResult() {
        return result;
    }

    public Button getBtnCheck() {
        return btnCheck;
    }





}
