/**
* Copyright (C) 2019 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.view.search.facet;

/**
 * @author pplitzner
 * @since Jan 24, 2019
 *
 */
public class Facet {

    private String category;
    private String facet;

    public Facet(String facet) {
        this(facet, null);
    }

    public Facet(String facet, String category) {
        this.category = category;
        this.facet = facet;
    }

    public String getCategory() {
        return category;
    }

    public String getFacet() {
        return facet;
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((category == null) ? 0 : category.hashCode());
        result = prime * result + ((facet == null) ? 0 : facet.hashCode());
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        Facet other = (Facet) obj;
        if (category == null) {
            if (other.category != null) {
                return false;
            }
        } else if (!category.equals(other.category)) {
            return false;
        }
        if (facet == null) {
            if (other.facet != null) {
                return false;
            }
        } else if (!facet.equals(other.facet)) {
            return false;
        }
        return true;
    }

}
