/**
* Copyright (C) 2019 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.view.search.facet;

import org.eclipse.jface.layout.GridDataFactory;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;

/**
 * @author pplitzner
 * @since Jan 23, 2019
 *
 */
public class FilterComposite extends Composite{
    private Button btnCheck;
    private Facet facet;

    public FilterComposite(Facet facet, SearchController controller, Composite parent, int style) {
        super(parent, style);
        this.facet = facet;
        GridDataFactory.fillDefaults().applyTo(this);
        GridLayout gridLayout = new GridLayout(2, false);
        gridLayout.marginHeight = 0;
        gridLayout.marginWidth = 0;
        gridLayout.horizontalSpacing = 0;
        setLayout(gridLayout);

        btnCheck = new Button(this, SWT.CHECK);
        btnCheck.addSelectionListener(new SelectionAdapter() {
            @Override
            public void widgetSelected(SelectionEvent e) {
                controller.applyFilter(FilterComposite.this);
            }
        });
        btnCheck.setSelection(true);

        Composite content = new Composite(this, SWT.NONE);
        GridDataFactory.fillDefaults().applyTo(content);
        GridLayout gl_content = new GridLayout();
        gl_content.horizontalSpacing = 0;
        content.setLayout(gl_content);

        Label label = new Label(content, SWT.NONE);
        label.setText(facet.getFacet());
        GridDataFactory.fillDefaults().applyTo(label);

    }

    public boolean isFilterActive() {
        return btnCheck.getSelection();
    }

    public Facet getFacet() {
        return facet;
    }

}
