/**
* Copyright (C) 2019 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.view.search.facet.occurrence;

import java.util.Set;
import java.util.stream.Collectors;

import eu.etaxonomy.cdm.api.service.dto.DerivedUnitDTO;
import eu.etaxonomy.taxeditor.view.search.facet.Facet;
import eu.etaxonomy.taxeditor.view.search.facet.SearchResult;

/**
 * @author pplitzner
 * @since Jan 24, 2019
 *
 */
public class OccurrenceSearchResult extends SearchResult<DerivedUnitDTO> {

    public OccurrenceSearchResult(DerivedUnitDTO content) {
        super(content);
    }

    @Override
    protected Set<Facet> initFacets(DerivedUnitDTO content) {
        Set<Facet> facets =  content.getAssociatedTaxa().stream().map(ref -> new Facet(ref.getLabel(), content.getKindOfUnit().getLabel())).collect(Collectors.toSet());
        return facets;
    }

}
