/**
* Copyright (C) 2019 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.view.search.facet.occurrence;

import org.eclipse.jface.layout.GridDataFactory;
import org.eclipse.jface.resource.JFaceResources;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.ControlAdapter;
import org.eclipse.swt.events.ControlEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;

import eu.etaxonomy.cdm.api.service.dto.DerivedUnitDTO;
import eu.etaxonomy.taxeditor.view.search.facet.CheckBoxSearchResultComposite;

/**
 * @author pplitzner
 * @since Jan 23, 2019
 *
 */
public class OccurrenceSearchResultComposite extends CheckBoxSearchResultComposite<DerivedUnitDTO, OccurrenceSearchResult> {

    private Label label;

    public OccurrenceSearchResultComposite(OccurrenceSearchResult result, Composite parent, int style) {
        super(result, parent, style);
    }

    @Override
    public Composite createContent(Composite parent) {
        Composite content = new Composite(this, SWT.NONE);
        content.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, false, 1, 1));
        GridLayout layout = new GridLayout(1, false);
        content.setLayout(layout);
        label = new Label(content, SWT.WRAP);
        label.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, false, 1, 1));
        label.setText(result.getContent().getLabel());
        label.setFont(JFaceResources.getFontRegistry().getBold(JFaceResources.DEFAULT_FONT));
        GridDataFactory.fillDefaults().applyTo(label);

        Label lblDescription = new Label(content, SWT.WRAP);
        GridData layoutData = new GridData();
        lblDescription.setLayoutData(layoutData);
        parent.addControlListener(new ControlAdapter() {
            @Override
            public void controlResized(ControlEvent e) {
                layoutData.widthHint = parent.getClientArea().width - (6*layout.marginWidth);
                parent.layout(true);
            }
        });
        String representation_L10n_text = result.getContent().getSummaryLabel();
        if(representation_L10n_text!=null){
            lblDescription.setText(representation_L10n_text);
        }
        return content;
    }

}
