/**
* Copyright (C) 2019 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.view.search.facet.term;

import java.util.HashSet;
import java.util.Set;

import eu.etaxonomy.cdm.api.service.l10n.TermRepresentation_L10n;
import eu.etaxonomy.cdm.model.term.TermType;
import eu.etaxonomy.cdm.persistence.dto.AbstractTermDto;
import eu.etaxonomy.cdm.persistence.dto.TermDto;
import eu.etaxonomy.taxeditor.view.search.facet.Facet;
import eu.etaxonomy.taxeditor.view.search.facet.SearchResult;

/**
 * @author pplitzner
 * @since Jan 24, 2019
 *
 */
public class TermSearchResult extends SearchResult<AbstractTermDto> {

    public TermSearchResult(AbstractTermDto content) {
        super(content);
    }

    @Override
    protected Set<Facet> initFacets(AbstractTermDto content) {
        Set<Facet> facets = new HashSet<>();
        content.localize(new TermRepresentation_L10n());
        TermType termType = content.getTermType();
        if (content instanceof TermDto){
            facets.add(new Facet(((TermDto)content).getVocRepresentation_L10n(), termType!=null?termType.getLabel():null));
        }else{
            facets.add(new Facet(content.getRepresentation_L10n(), termType!=null?termType.getLabel():null));
        }
        return facets;
    }

}
