/**
* Copyright (C) 2018 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.view.webimport.termimport;

import java.util.ArrayList;
import java.util.Collection;

import org.eclipse.jface.viewers.ITreeContentProvider;

import eu.etaxonomy.taxeditor.view.webimport.termimport.parser.OntologyTermParser;
import eu.etaxonomy.taxeditor.view.webimport.termimport.requests.RequestBroader;
import eu.etaxonomy.taxeditor.view.webimport.termimport.wrapper.OntologyTermWrapper;

/**
 * @author pplitzner
 * @since Apr 23, 2018
 *
 */
public class OntologyTermContentProvider implements ITreeContentProvider {

    @Override
    public Object[] getElements(Object inputElement) {
        Collection<Object> elements = new ArrayList<>();
        if(inputElement instanceof Collection){
            elements = (Collection<Object>) inputElement;
        }
        return elements.toArray();
    }

    @Override
    public Object[] getChildren(Object parentElement) {
        if(parentElement instanceof OntologyTermWrapper){
            OntologyTermWrapper wrapper = (OntologyTermWrapper) parentElement;
            String response = new RequestBroader(wrapper.getUri(), wrapper.getSourceTerminology()).request();
            Collection<OntologyTermWrapper> broader = OntologyTermParser.parse(response, ((OntologyTermWrapper) parentElement).getSourceTerminology());
            return broader.toArray();
        }
        return null;
    }

    @Override
    public Object getParent(Object element) {
        return null;
    }

    @Override
    public boolean hasChildren(Object element) {
        return true;
    }

}
