/**
* Copyright (C) 2018 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.view.webimport.termimport.parser;

import java.util.Collection;
import java.util.LinkedList;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import eu.etaxonomy.taxeditor.view.webimport.termimport.wrapper.HierarchyTermWrapper;

/**
 * @author pplitzner
 * @since May 9, 2018
 *
 */
public class HierarchyParser {
    public static Collection<HierarchyTermWrapper> parse(String response){
        LinkedList<HierarchyTermWrapper> wrapperList = new LinkedList<>();
        try {
            JSONObject jsonResponse = new JSONObject(response);
            JSONArray responseArray = ParserUtil.parseResults(jsonResponse);
            HierarchyTermWrapper childTerm = null;
            for(int i=0;i<responseArray.length();i++){
                JSONObject jsonObject = responseArray.getJSONObject(i);
                String label = ParserUtil.parseLabel(jsonObject);
                String uri= ParserUtil.parseUri(jsonObject);
                HierarchyTermWrapper hierarchyTermWrapper = new HierarchyTermWrapper(uri, label);
                wrapperList.add(hierarchyTermWrapper);
                if(childTerm!=null){
                    childTerm.setParentTerm(hierarchyTermWrapper);
                }
                childTerm = hierarchyTermWrapper;
            }
        } catch (JSONException jsonException) {
            jsonException.printStackTrace();
        }
        return wrapperList;
    }

}
