/**
* Copyright (C) 2018 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.view.webimport.termimport.parser;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import eu.etaxonomy.taxeditor.view.webimport.termimport.requests.RequestTerm;
import eu.etaxonomy.taxeditor.view.webimport.termimport.wrapper.OntologyTermWrapper;

/**
 * @author pplitzner
 * @since May 9, 2018
 *
 */
public class SuggestParser {
    public static Collection<OntologyTermWrapper> parse(String response){
        List<OntologyTermWrapper> wrapperList = new ArrayList<>();
        try {
            JSONObject jsonResponse = new JSONObject(response);
            JSONArray responseArray = ParserUtil.parseResults(jsonResponse);
            for(int i=0;i<responseArray.length();i++){
                JSONObject jsonObject = responseArray.getJSONObject(i);
                String label = ParserUtil.parseLabel(jsonObject);
                String uri= ParserUtil.parseUri(jsonObject);
                String sourceTerminology = ParserUtil.parseTerminology(jsonObject);
                String request = new RequestTerm(uri, sourceTerminology).request();
                OntologyTermWrapper wrapper = new OntologyTermWrapper(uri, label, sourceTerminology);
                wrapperList.add(wrapper);
            }
        } catch (JSONException jsonException) {
            jsonException.printStackTrace();
        }
        return wrapperList;
    }

}
