/**
* Copyright (C) 2018 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.view.webimport.termimport.parser;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import eu.etaxonomy.taxeditor.view.webimport.termimport.wrapper.TerminologyWrapper;

/**
 * @author pplitzner
 * @since May 9, 2018
 *
 */
public class TerminologyParser {
    public static Collection<TerminologyWrapper> parse(String response) throws JSONException{
        List<TerminologyWrapper> wrapperList = new ArrayList<>();
        JSONObject jsonResponse = new JSONObject(response);
        JSONArray responseArray = jsonResponse.getJSONArray("results");
        for(int i=0;i<responseArray.length();i++){
            JSONObject jsonObject = responseArray.getJSONObject(i);
            String name = jsonObject.getString("name");
            String acronym = jsonObject.getString("acronym");
            String description = ParserUtil.parseDescription(jsonObject);
            String uri = ParserUtil.parseUri(jsonObject);
            wrapperList.add(new TerminologyWrapper(name, acronym, description, uri));
        }
        return wrapperList;
    }

}
