/**
* Copyright (C) 2018 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.view.webimport.termimport.requests;

import java.util.ArrayList;
import java.util.List;

/**
 * @author pplitzner
 * @since Apr 23, 2018
 *
 */
public class RequestTerm extends AbstractTerminologyServiceRequest{

    private String termUri;
    private String ontologyLabel;

    public RequestTerm(String termUri, String ontologyLabel) {
        super();
        this.termUri = termUri;
        this.ontologyLabel = ontologyLabel;
    }

    @Override
    protected String getServiceUri() {
        return "term";
    }

    @Override
    protected String getTerminologyId() {
        return ontologyLabel;
    }

    @Override
    protected List<RequestParameter> getServiceParameters() {
        List<RequestParameter> params = new ArrayList<>();
        params.add(new RequestParameter(TerminologyServiceConstants.ATTR_URI, termUri));
        return params;
    }

}
