/**
* Copyright (C) 2018 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.view.webimport.termimport.wrapper;

import java.util.List;

import eu.etaxonomy.cdm.model.term.TermVocabulary;

/**
 * Wrapper for terms received from the GfBio terminology service.
 *
 * @author pplitzner
 * @since Apr 23, 2018
 *
 */
public class OntologyTermWrapper extends TermWrapper{

    private String sourceTerminology;
    private String description;
    private List<String> synonyms;
    private String comment;
    private TermVocabulary termVocabulary;
    public OntologyTermWrapper(String uri, String label, String sourceTerminology) {
        super(uri, label);
        this.sourceTerminology = sourceTerminology;
    }
    public String getSourceTerminology() {
        return sourceTerminology;
    }
    public String getDescription() {
        return description;
    }
    public void setDescription(String description) {
        this.description = description;
    }
    public List<String> getSynonyms() {
        return synonyms;
    }
    public void setSynonyms(List<String> synonyms) {
        this.synonyms = synonyms;
    }
    public String getComment() {
        return comment;
    }
    public void setComment(String comment) {
        this.comment = comment;
    }
    public void setSourceTerminology(String sourceTerminology) {
        this.sourceTerminology = sourceTerminology;
    }
    public TermVocabulary getTermVocabulary() {
        return termVocabulary;
    }
    public void setTermVocabulary(TermVocabulary termVocabulary) {
        this.termVocabulary = termVocabulary;
    }
}
