/**
* Copyright (C) 2018 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.view.webimport.termimport.wrapper;

/**
 * @author pplitzner
 * @since Apr 23, 2018
 *
 */
public class TerminologyWrapper {

    private String name;
    private String acronym;
    private String description;
    private String uri;
    public TerminologyWrapper(String name, String acronym, String description, String uri) {
        this.name = name;
        this.acronym = acronym;
        this.description = description;
        this.uri = uri;
    }
    public String getName() {
        return name;
    }
    public String getAcronym() {
        return acronym;
    }
    public String getDescription() {
        return description;
    }
    public String getUri() {
        return uri;
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((acronym == null) ? 0 : acronym.hashCode());
        result = prime * result + ((description == null) ? 0 : description.hashCode());
        result = prime * result + ((name == null) ? 0 : name.hashCode());
        result = prime * result + ((uri == null) ? 0 : uri.hashCode());
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        TerminologyWrapper other = (TerminologyWrapper) obj;
        if (acronym == null) {
            if (other.acronym != null) {
                return false;
            }
        } else if (!acronym.equals(other.acronym)) {
            return false;
        }
        if (description == null) {
            if (other.description != null) {
                return false;
            }
        } else if (!description.equals(other.description)) {
            return false;
        }
        if (name == null) {
            if (other.name != null) {
                return false;
            }
        } else if (!name.equals(other.name)) {
            return false;
        }
        if (uri == null) {
            if (other.uri != null) {
                return false;
            }
        } else if (!uri.equals(other.uri)) {
            return false;
        }
        return true;
    }

}
